#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <random>
#include <set>

using namespace std;

std::vector<std::vector<long long>> g;

void solve() {
    long long n, m;
    std::cin >> n >> m;
    g.assign(n + 1, std::vector<long long>());
    for (int i = 0; i < m; ++i) {
        int u, v;
        std::cin >> u >> v;
        g[u].push_back(v);
    }
    std::vector<long long> vec(n);
    iota(vec.begin(), vec.end(), 1ll);
    long long count = 0;
    for (int i = 1; i <= n; ++i) {
        for (auto u : g[i]) {
            count += (i < u);
        }
    }
    if ((m + 1) / 2 > count) {
        std:reverse(vec.begin(), vec.end());
    }
    for (auto u : vec) std::cout << u << ' ';
}

int main() {
    cin.tie(0)->sync_with_stdio(false);
    int tests = 1; cin >> tests;
    while (tests--) {
        solve();
        cout << '\n';
    }
}