import java.util.ArrayList;
import java.util.Scanner;

public class Main {
    public static int comp(int[] a, int[] b) {
        if (a[0] == b[0]) {
            return Integer.compare(a[1], b[1]);
        }

        return Integer.compare(a[0], b[0]);
    }

    public static void main(String[] args) {
        var scanner = new Scanner(System.in);

        int tests = scanner.nextInt();
        var results = new int[tests];

        int n;

        for (int k = 0; k < tests; k++) {
            n = scanner.nextInt();

            var arr = new ArrayList<int[]>();

            for (int i = 0; i < n; i++) {
                arr.add(new int[]{scanner.nextInt(), 0});
            }

            for (int i = 0; i < n; i++) {
                arr.get(i)[1] = scanner.nextInt();
            }

            arr.sort(Main::comp);

            boolean isValid = true;
            int prev = -1;

            for (int i = 0; i < n; i++) {
                int q = arr.get(i)[1] - arr.get(i)[0];
                if (q < 0 || q < prev) {
                    isValid = false;
                    break;
                }
                prev = q;
            }

            if (isValid) {
                results[k] = prev;
            } else {
                results[k] = -1;
            }
        }

        for (var elem: results) {
            System.out.println(elem);
        }
    }
}

/*
4
4
3 2 4 2
5 3 6 2
1
10
100000
5
1 2 3 4 5
1 2 3 4 5
3
1 4 6
4 1 8
 */

/*
7
2
0 2
1 7
1
4
1
2
0 2
1 2
3
1 1 3
1 2 3
2
1 0
1 1
3
1 3 3
1 4 3
3
1 2 3
1 4 3
 */