#include <iostream>
#include <vector>
#include <string>
#include <memory>
#include <cstring>

using namespace std;

#define int long long
#define bit(i, n) (((n) >> (i)) & 1)

int dp[101][1 << 16][8];

int n;
int need;
string s;
int f(int n, int mask, int suff) {
    if (n == ::n) {
        if (mask != 0) return 0;
        return 1;
    }
    int& ans = dp[n][mask][suff];
    if (ans != -1) return ans;
    ans = 0;

    if (n < s.size() || bit(suff * 2, mask) == 1) {
        ans += f(n + 1, mask, suff * 2 % (1 << s.size()));
        if (n >= s.size()) {
            ans += f(n + 1, mask ^ (1 << (2 * suff)), suff * 2 % (1 << s.size()));
        }
    }
    while (ans >= 998244353) {
        ans -= 998244353;
    }
    if (n < s.size() || bit(suff * 2 + 1, mask) == 1) {
        ans += f(n + 1, mask, (suff * 2 + 1) % (1 << s.size()));
        ans %= 998244353;
        while (ans >= 998244353) {
            ans -= 998244353;
        }
        if (n >= s.size()) ans += f(n + 1, mask ^ (1 << (suff * 2 + 1)), (suff * 2 + 1) % (1 << s.size()));
    }
    while (ans >= 998244353) {
        ans -= 998244353;
    }
    return ans;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    memset(dp, -1, sizeof dp);




    int n, m, k; cin >> n >> m >> k;
    int MAXN = 1 << (1 << (k + 1));
    cin >> s;
    if (n == m && n == k) {
        cout << 1;
        return 0;
    }

    if (s.size() == 3)need = (s[0] - '0') * 4 + (s[1] - '0') * 2 + s[2] - '0';
    else if (s.size() == 2) need = (s[0] - '0') * 2 + s[1] - '0';
    else need = s[0] - '0';

    vector<int> cnt1(1 << 16);
    vector<int> cnt2(1 << 16);
    ::n = n;

    auto ok2 = [&](int mask) {
        return mask % (1 << s.size()) == need || mask / 2 == need;
    };

    auto ok = [&](int mask) {
        for (int i = 0; i < (1 << (s.size() + 1)); ++i) {
            if (bit(i, mask) && ok2(i)) return true;
        }
        return false;
    };


    for (int i = 0; i < MAXN; ++i) {
        cnt1[i] = f(0, i, 0) * ok(i);
    }
    if (n == k) cnt1[0] = 1;
    memset(dp, -1, sizeof dp);
    ::n = m;
    for (int i = 0; i < MAXN; ++i) {
        cnt2[i] = f(0, i, 0) * ok(i);
    }
    if (m == k) cnt2[0] = 1;

    const int D = 998244353;

    for (int j = 0; j < 16; ++j) {
        for (int i = 0; i < MAXN; ++i) {
            if (bit(j, i)) {
                cnt2[i] += cnt2[i ^ (1 << j)];
                if (cnt2[i] >= D) {
                    cnt2[i] -= D;
                }
            }
        }
    }

    int ans = 0;

    for (int i = 0; i < MAXN; ++i) {
        ans += cnt1[i] * cnt2[(MAXN - 1) ^ i];
        ans %= D;
    }

    cout << ans;
}