#include <bits/stdc++.h>

using namespace std;

using ll = long long;

template<typename T>
ostream& operator<<(ostream& ost, vector<T>& v){
    ost<<"[";
    for(auto x : v)
        ost<<x<<" ";
    return ost<<"]\n";
}

bool calc(vector<int>& x){
    int n = x.size();
    bool same = true;
    for (int i = 0; i < n && same; ++i)
    {
        same &= x[i] == x[0];
    }
    if(same)
        return x[0] >= 0 && x[0] % 3 == 0;
    for (int i = 0; i < n; ++i)
    {
        if(x[i]&1){
            --x[i];
            x[(i+1)%n] -= 2;
        }
    }
    bool good = true;
    for (int i = 0; i < n && good; ++i)
    {
        good &= x[i] >= 0;
        x[i] >>= 1;
    }
    return good && calc(x);
}

void solve(){
    int n;
    cin>>n;
    vector<int> v(n);
    for (int i = 0; i < n; ++i)
    {
        cin>>v[i];
    }
    vector<int> ans = {0};
    for (int i = 0; i < 3; ++i)
    {
        int l = 0, r = int(1e9)/3 + 10;
        while(r - l > 1){
            int m = (l + r)/2;
            //cout<<l<<" "<<m<<" "<<r<<endl;
            vector<int> x(n);
            for (int j = 0; j < n; ++j)
            {
                x[j] = v[j] - 3*m + i;
            }
            //cout<<m<<" "<<i<<": "<<x<<endl;
            if(calc(x)){
                l = m;
            }
            else{
                r = m;
            }
        }
        ans.push_back(3*l - i);
    }
    cout<< *std::max_element(ans.begin(), ans.end())<<"\n";
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin>>n;
    while(n--)
        solve();
}
