#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC optimize("O3")

using namespace std;

using ll = long long;

template<typename T>
ostream& operator<<(ostream& ost, vector<T>& v){
    ost<<"[";
    for(auto x : v)
        ost<<x<<" ";
    return ost<<"]\n";
}

bool calc(vector<int>& x){
    int n = x.size();
    bool same, good;
    while(true)
    {
        same = true;
        good = true;
        if(x[0]&1){
            --x[0];
            x[1]-=2;
        }
        x[0] >>= 1;
        for (int i = 1; i < n-1; ++i)
        {
            if (x[i] & 1)
            {
                --x[i];
                x[i + 1] -= 2;
            }
            x[i] >>= 1;
            good &= x[i] >= 0;
            same &= x[i] == x[0];
        }
        if(x[n-1]&1){
            --x[n-1];
            --x[0];
            same = false;
            good &= x[0] >= 0;
        }
        x[n-1] >>= 1;
        same &= x[n-1] == x[0];
        good &= x[n-1] >= 0;
        if (same)
            return x[0] >= 0 && x[0] % 3 == 0;
        if(!good)
            return false;
    }
}

void solve(){
    int n;
    cin>>n;
    vector<int> v(n);
    for (int i = 0; i < n; ++i)
    {
        cin>>v[i];
    }
    vector<int> ans = {0};
    for (int i = 0; i < 3; ++i)
    {
        int l = 0, r = int(1e9)/3 + 10;
        while(r - l > 1){
            int m = (l + r)/2;
            //cout<<l<<" "<<m<<" "<<r<<endl;
            vector<int> x(n);
            for (int j = 0; j < n; ++j)
            {
                x[j] = v[j] - 3*m + i;
            }
            //cout<<m<<" "<<i<<": "<<x<<endl;
            if(calc(x)){
                l = m;
            }
            else{
                r = m;
            }
        }
        ans.push_back(3*l - i);
    }
    cout<< *std::max_element(ans.begin(), ans.end())<<"\n";
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin>>n;
    while(n--)
        solve();
}