//
// Created by qf on 16.11.2024.
//
#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define all(x) x.begin(),x.end()

using namespace std;

constexpr ll MOD = 998244353;

ll n, m, k;
ll f[105];

set<pair<ll, ll>> c;

ll binpow(ll h, ll r) {
    ll l = 1;
    while (r) {
        if (r & 1) {
            l = l * h % MOD;
        }
        h = h * h % MOD;
        r /= 2;
    }
    return l;
}

struct bint {
    ll v;

    bint(ll v) : v(v){};
};

bint operator+(bint a, bint b) {
    return {a.v + b.v % MOD};
}

bint operator-(bint a, bint b) {
    return {(a.v + MOD - b.v) % MOD};
}

bint operator*(bint a, bint b) {
    return {(a.v * b.v) % MOD};
}

bint operator/(bint a, bint b) {
    return {(a.v * binpow(b.v, MOD - 2)) % MOD};
}

bint operator^(bint a, bint b) {
    return {binpow(a.v, b.v)};
}

bint operator+=(bint& a, bint b) {
    a = a + b;
    return a;
}

bint operator-=(bint& a, bint b) {
    a = a - b;
    return a;
}

bint operator*=(bint& a, bint b) {
    a = a * b;
    return a;
}

bint operator/=(bint& a, bint b) {
    a = a / b;
    return a;
}

bint operator^=(bint& a, bint b) {
    a = a ^ b;
    return a;
}

bint ff(ll a) {
    if (k == 2) {
        return {(a + 1) % 2};
    } else {
        bint kk{k};
        bint an = ((kk - 2) * (((((kk - 1) ^ 2)^(a / 2 + 1)) - 1) / (((kk - 1) ^ 2) - 1) - 1)) / (kk - 1) + 1;
        if (a & 1) {
            an = ((kk - 1) ^ a) - an;
        }
        return an;
    }
}

bint dfs(ll l, ll r) {
    if (l + 1 == r) {
        return {1};
    }
    ll j = l;
    vector<pair<ll, ll>> zz;
    while (j < r) {
        auto it = std::upper_bound(c.begin(), c.end(), make_pair(j, (ll)-1e18));
        if (it == c.end()) {
            break;
        }
        auto o = -it->second;
        c.erase(it);
        zz.emplace_back(j, o);
        j = o;
    }
    ll am = r - l - 1;
    for (auto [x, y] : zz) {
        am -= y - x - 1;
    }
    bint ans = ff(am);
    for (auto [x, y] : zz) {
        ans *= dfs(x, y);
    }
    // cout << l << " " << r << " " << am << " " << ff(am).v << " " << ans.v << endl;
    return ans;
}

void solve() {
    cin >> n >> m >> k;
    for (int i = 0; i < m; i++) {
        ll x, y;
        cin >> x >> y;
        c.insert({x, -y});
    }
    bint ans = dfs(1, n) * k * (k - 1);
    cout << ans.v << endl;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}