#include<iostream>
#include<string>
#include<vector>
#include<set>
#include<algorithm>
#include<cassert>

using namespace std;

typedef long long ll;

int solve() {
    int n;
    cin >> n;
    struct T {
        ll x, cnt;
        bool sec;
    };

    vector<T> a(n);
    ll tot[2] = {0, 0};
    for (auto &[x, cnt, sec] : a) {
        cin >> x >> cnt;
        char c;
        cin >> c;
        sec = c == 'B';
        tot[sec] += cnt;
    }
    int last = 0;
    for (int i = n - 1; i >= 0; i--) {
        if (!a[i].sec) {
            last = a[i].x;
            break;
        }
    }

    if (tot[0] == tot[1]) {
        return cout << "Draw " << last << " +\n", 0;
    }

    bool win = tot[1] > tot[0];

    ll diff = 0;
    ll extra = 0;

    bool can_win = 0;
    bool draw = 0;
    bool p = a[n - 1].sec;
    ll lastx = a[n - 1].x;

    ll moves[2] = {0};

    for (int i = n - 1; i >= 0; i--) {
        if (a[i].sec == p) {
            diff += a[i].cnt;
            extra += a[i].x * a[i].cnt;    
        } else {
            ll need = min(diff, a[i].cnt);
            diff -= need;
            a[i].cnt -= need;
            ll waste = extra - need * a[i].x;
            if (a[i].sec == win) {
                if (moves[win] + waste - (int)(win == 0) > moves[win ^ 1] && need > 0) {
                    draw = 1;
                    break;
                }
            }
            moves[a[i].sec] += waste;
            extra -= waste;
            if (diff == 0 && a[i].cnt > 0) {
                extra = a[i].cnt * i;
                diff = a[i].cnt;
                p = a[i].sec;
            }
        }
    }

    if (draw) {
        return cout << "Draw " << last << " +\n", 0;
    }
    if (!draw) {
        if (win) {
            return cout << "Second\n", 0;
        } else {
            return cout << "First " << last << " +\n", 0;
        }
    }

    return 0;
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}