#include <bits/stdc++.h>

typedef long long ll;

using namespace std;

struct circle {
    int x;
    int y;
    int r;
};

double dist(double ax, double ay, double bx, double by) {
    return sqrt(pow(ax - bx, 2) + pow(ay - by, 2));
}

void solve() {
    vector<circle> cs;
    int tn;
    ll p = 0;
    cin >> tn;
    for (int j = 0; j < tn; j++) {
        circle c = circle();
        cin >> c.x >> c.y >> c.r;
        for (auto & i : cs) {
            if (dist(c.x, c.y, i.x, i.y) == c.r + i.r) p++;
        }
        cs.push_back(c);
    }
    cout << p << endl;
}

int main() {
    ios_base::sync_with_stdio(false);

    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        solve();
    }

    return 0;
}
