#include <bits/stdc++.h>

typedef long long ll;

using namespace std;

struct circle {
    int x;
    int y;
    int r;
};

map<tuple<double, double, double, double, double, double>, bool> hsh = {};

bool _is_p(double ax, double bx, double ay, double by, double ar, double br) {
    return sqrt((ax - bx) * (ax - bx) + (ay - by) * (ay - by)) == ar + br;
}

bool is_p(circle a, circle b) {
    auto t = tuple<double, double, double, double, double, double>(a.x, b.x, a.y, b.y, a.r, b.r);
    if (hsh.contains(t)) return hsh[t];
    return _is_p(a.x, b.x, a.y, b.y, a.r, b.r);
}

void solve() {
    vector<circle> cs;
    int tn;
    ll p = 0;
    cin >> tn;
    cs.reserve(tn);
    for (int j = 0; j < tn; j++) {
        circle c = circle();
        cin >> c.x >> c.y >> c.r;
        for (auto & i : cs) {
            if (is_p(c, i)) p++;
        }
        cs.push_back(c);
    }
    cout << p << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);

    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        solve();
    }

    return 0;
}
