#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;
    vector<string> a;
    vector<bool> always_typed(m, false);
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        a.push_back(s);

        bool b = true;
        for (int j = 1; j < s.size(); j++) {
            if (s[j] != s[0]) {
                b = false;
                break;
            }
        }
        if (b)
            always_typed[s[0] - 'a'] = true;
    }

    bool all_typed = true;
    for (int i = 0; i < m; i++) {
        if (!always_typed[i]) {
            all_typed = false;
            break;
        }
    }
    if (all_typed) {
        cout << "NO" << endl;
        return 0;
    }

    vector<int> s(m, 1);
    for (int i = 0; i < n; i++) {
        if (always_typed[a[i][0] - 'a']) continue;
        int j = 1;
        for (;j < a[i].size() && a[i][j] == a[i][0]; j++);
        s[a[i][0] - 'a'] += j;
    }

    char c;
    int min = 1 << 30;
    for (int i = 0; i < m; i++) {
        if (!always_typed[i]) {
            if (s[i] < min) {
                min = s[i];
                c = i + 'a';
            }
        }
    }
    for (int i = 0; i < min; i++)
        cout << c;
    cout << endl;
}