#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define sz(a) (int)a.size()
#define all(a) a.begin(), a.end()
#define fori(a, b) for(int i = a; i < b; ++i)
#define forj(a, b) for(int j = a; j < b; ++j)
#define fork(a, b) for(int k = a; k < b; ++k)

const ll linf = (ll)2e18;
const int inf = (int)2e9;
const ll mod = (ll)998244353;

using namespace std;

ll fast_pow(ll a, ll n) {
    if (n == 0ll) {
        return 1ll;
    }
    if (n & 1) {
        return a * fast_pow(a, n - 1) % mod;
    }
    ll x = fast_pow(a, n >> 1);
    return x * x % mod;
}

void solve() {
    int n;
    cin >> n;

    vector<int> x(n);
    vector<int> y(n);



    for (int i = 0; i < n; ++i) {
        cin >> x[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> y[i];
    }

    reverse(all(x));
    reverse(all(y));

    vector<vector<ll>> dp1(n + 1, vector<ll>(2));

    dp1[n][0] = 0;
    dp1[n][1] = 0;

    for (int i = n - 1; i >= 0; --i) {
        if (x[i] == 1) {
            dp1[i][0] = dp1[i + 1][0];
            dp1[i][1] = (dp1[i + 1][1] + 2 * fast_pow(3, n - i - 1) % mod) % mod;
        } else if (x[i] == 3) {
            dp1[i][1] = dp1[i + 1][1];
            dp1[i][0] = (dp1[i + 1][0] + 2 * fast_pow(3, n - i - 1) % mod) % mod;
        } else if (x[i] == 2) {
            dp1[i][0] = (dp1[i + 1][1] + fast_pow(3, n - i - 1)) % mod;
            dp1[i][1] = (dp1[i + 1][0] + fast_pow(3, n - i - 1)) % mod;
        }
    }

    vector<vector<ll>> dp2(n + 1, vector<ll>(2));
    dp2[n][0] = 0;
    dp2[n][1] = 0;

    for (int i = n - 1; i >= 0; --i) {
        if (y[i] == 1) {
            dp2[i][0] = dp2[i + 1][0];
            dp2[i][1] = (dp2[i + 1][1] + 2 * fast_pow(3, n - i - 1) % mod) % mod;
        } else if (y[i] == 3) {
            dp2[i][1] = dp2[i + 1][1];
            dp2[i][0] = (dp2[i + 1][0] + 2 * fast_pow(3, n - i - 1) % mod) % mod;
        } else if (y[i] == 2) {
            dp2[i][0] = (dp2[i + 1][1] + fast_pow(3, n - i - 1)) % mod;
            dp2[i][1] = (dp2[i + 1][0] + fast_pow(3, n - i - 1)) % mod;
        }
    }

    ll ans = 0ll;
    for (int i = 0; i < n; ++i) {
        if (x[i] != y[i]) {
            if (x[i] == 1 && y[i] == 2) {
                //cout << "lol\n";
                ans = (dp1[i + 1][1] + 1 + dp2[i + 1][1]) % mod;
            } else if (x[i] == 1 && y[i] == 3) {
                //cout << "lol\n";
                ans = (dp1[i + 1][1] + fast_pow(3, n - i - 1) + 1) % mod;
                ans = (ans + dp2[i + 1][0]) % mod;
            } else if (x[i] == 2 && y[i] == 1) {
                ans = (dp1[i + 1][1] + 1 + dp2[i + 1][1]) % mod;
            } else if (x[i] == 2 && y[i] == 3) {
                ans = (dp1[i + 1][0] + 1 + dp2[i + 1][0]) % mod;
            } else if (x[i] == 3 && y[i] == 1) {
                ans = (dp1[i + 1][0] + fast_pow(3, n - i - 1) + 1) % mod;
                ans = (ans + dp2[i + 1][1]) % mod;
            } else if (x[i] == 3 && y[i] == 2) {
                ans = (dp1[i + 1][0] + 1 + dp2[i + 1][0]) % mod;
            }

            break;
        }
    }

    cout << ans << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
    //cout << fixed << setprecision(7);
    //freopen("test.in", "r", stdin);
    //freopen("test.in", "w", stdout);

    int tests = 1;
    cin >> tests;
    for (int test = 1; test <= tests; ++test) {
        solve();
    }
}
