#include <bits/stdc++.h>
using namespace std;

#define endl '\n'
#define ll long long
#define pb push_back
#define F first
#define S second

const int timeStart = 8 * 60;
const int threshold = 10;

vector<pair<int, int>> input() {
    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i].F;
    for (int i = 0; i < n; ++i)
        cin >> a[i].S;
    return a;
}

int solve(vector<pair<int, int>> &input) {
    int n = input.size();
    for (int i = 0; i < n; ++i) {
        if (input[i].F > input[i].S) {
            return -1;
        }
    }
    sort(input.begin(), input.end());
    int sub = 0;
    for (int i = 0; i < n; ++i) {
        if (input[i].S - input[i].F < sub) {
            return -1;
        } sub += input[i].S - input[i].F - sub;
    }
    return sub;
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output1.txt", "w", stdout);
    #endif // LOCAL
    int t;
    cin >> t;
    while (t--) {
        auto in = input();
        auto ans = solve(in);
        cout << ans << endl;
    }
    return 0;
}
