#include <algorithm>
#include <bitset>
#include <cmath>
#include <vector>
#include <numeric>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <string>
#include <tuple>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <iostream>
#include <iterator>
#include <limits>
#include <iomanip>

#define ll long long
#define ull unsigned long long
#define ld long double

#define INF 1000000000000000ll
#define MOD 1000000007ll
#define PI 3.1415926535897932384626433832795

using namespace std;
template <class T>
void print_v(vector<T> &v) { cout << "{"; for (auto x : v) cout << x << ","; cout << "\b}"; }

ll gcd(ll a,ll b) { if (b==0) return a; return gcd(b, a%b); }
bool prime(ll a) { if (a==1) return 0; for (int i=2;i<=round(sqrt(a));++i) if (a%i==0) return 0; return 1; }


void solution() {
    ll n;
    cin >> n;
    vector<pair<ll, ll>> hp(n);
    for (int i = 0; i < n; ++i) {
        cin >> hp[i].first;
    }
    for (int i = 0; i < n; ++i) {
        cin >> hp[i].second;
    }
    sort(hp.begin(), hp.end());
    for (int i = 1; i < n; ++i) {
        if (hp[i].second > hp[i - 1].second && hp[i].second <= hp[i - 1].second) {
            cout << "-1\n";
            return;
        }
        if (hp[i].second < hp[i].first) {
            cout << "-1\n";
            return;
        }
        if (hp[i].second - hp[i].first < hp[i - 1].second - hp[i - 1].first) {
            cout << "-1\n";
            return;
        }
    }
    cout << hp[n - 1].second - hp[n - 1].first << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cout.precision(12);
    fixed(cout);

    ll tt = 1;
    cin >> tt;
    while (tt--) solution();

    return 0;
}
