#include <bits/stdc++.h>

using namespace std;
using ull = unsigned long long;
using ll  = long long;
using ld = long double;
#define pb push_back
#define fi first 
#define se second
#define vi vector<int> 
#define vl vector<ll> 
#define vvi vector<vi> 
#define vvl vector<vl> 
#define pii pair<int,int>
#define pll pair<ll, ll>
#define vii vector<pii> 
#define vll vector<pll> 
#define vvii vector<vii>
#define vvll vector<vll>
#define all(x) begin(x), end(x)
#define sz(x) (int)x.size()

#ifndef LOCAL
#define cerr if (0) cerr
#endif

template <typename T, typename V> ostream &operator<<(ostream &out, pair<T, V> p) {
	out << "(" << p.fi << ", " << p.se << ")";
	return out;
}

template <typename T> ostream &operator<<(ostream &out, vector<T> v) {
	out << "[";
	for (T e : v)
		out << e << ", ";
	out << "]";
	return out;
}

template <typename T> ostream &operator<<(ostream &out, vector<vector<T>> v) {
	out << "[";
	for (auto e : v)
		out << e << ",\n";
	out << "]";
	return out;
}

template <typename T, typename C> ostream &operator<<(ostream &out, set<T, C> s) {
	out << "{";
	for (T e : s)
		out << e << ", ";
	out << "}";
	return out;
}

template <typename T, typename V, typename C> ostream &operator<<(ostream &out, map<T, V, C> m) {
	out << "{";
	for (auto e : m)
		out << e << ", ";
	out << "}";
	return out;
}

int n, m;
vvi gr;
vi c, tp, en;

inline void topsort(int v)
{
    c[v] = 1;
    for(int u : gr[v])
    {
        if(c[u]) continue;

        topsort(u);
    }

    tp.pb(v);
}

bool check()
{
    for(int i = 0; i < n; i++)
        en[tp[i]] = i;
    
    int cnt = 0;

    for(int v = 0; v < n; v++)
        for(int u : gr[v])
            cnt += (en[v] < en[u]);

    return cnt >= (m / 2 + m % 2);
}

void solve() {
    gr.clear();
    c.clear();
    tp.clear();
    en.clear();

    cin >> n >> m;

    gr.resize(n);
    c.resize(n, 0);
    en.resize(n, 0);

    for(int i = 0; i < m; i++)
    {
        int u, v;
        cin >> u >> v;
        u--, v--;

        gr[u].pb(v);
    }

    for(int i = 0; i < n; i++)
        if(!c[i])
            topsort(i);

    if(!check())
        reverse(tp.begin(), tp.end());

    for(int e : tp)
        cout << e + 1 << " ";
}

int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	// freopen("in.txt", "r", stdin);
	// freopen("out.txt", "w", stdout);

	// cout << fixed << setprecision(10);

	int t = 1;
	cin >> t;

	while (t --> 0) {
		solve();
        cout << "\n";
	}

	return 0;
}