#include<iostream>
#include<iomanip>
#include<string>
#include<vector>
#include<map>
#include<unordered_map>
#include<unordered_set>
#include<queue>
#include<deque>
#include<algorithm>
#include<cmath>
#include<cctype>
#include<fstream>
#include<ios>
#include<bitset>
#include<numbers>
#include <random>
#include <set>

using namespace std;
#define sort(a) sort(a.begin(), a.end())
#define reverse(a) reverse(a.begin(), a.end())
#define all(a) a.begin(), a.end()
#define pb push_back
mt19937 rnd(time(nullptr));

typedef long long ll;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int test;
    cin >> test;
    while(test--) {
        int n;
        cin >> n;
        vector<int> h(n), p(n);
        for (int& now : h) cin >> now;
        for (int& now : p) cin >> now;
        vector<pair<int, int>> ps(n);
        for (int i = 0; i < n; ++i) {
            ps[i] = {p[i], h[i]};
        }
        sort(ps);
        reverse(ps);
        bool good = true;
        for (int i = 0; i < n - 1; ++i) {
            if (ps[i].second < ps[i + 1].second) {
                good = false;
            }
        }
        if (!good) {
            cout << -1 << '\n';
            continue;
        }
        vector<int> diff(n);
        for (int i = 0; i < n; ++i) {
            diff[i] = ps[i].first - ps[i].second;
        }
        vector<int> sufmax(n);
        sufmax[n - 1] = diff[n - 1];
        for (int i = n - 2; i >= 0; --i) {
            sufmax[i] = max(sufmax[i], diff[i]);
        }
        int curmax = -1;
        for (int i = 0; i < n; ++i) {
            if (diff[i] == sufmax[i]) {
                curmax = max(curmax, diff[i]);
            } else {
                good = false;
                break;
            }
        }
        if (!good) {
            cout << -1 << '\n';
        } else {
            cout << curmax << '\n';
        }
    }
}
