#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;
using ll = long long;

void solve();

int main() {
	ll t; cin >> t;
	while(t--)
	solve();

	return 0;
}

ll inf = 1e18;
ll MOD = 998244353;


ll bin_pow_mod(ll a, ll n)
{
	ll res = 1;
	while (n)
	{
		if (n & 1)
		{
			res *= a;
			res %= MOD;
		}

		n >>= 1;
		a *= a;
		a %= MOD;
	}

	return res;
}

void solve()
{
	ll n; cin >> n;
	vector<ll> x(n), m(n);
	vector<char> c(n);
	ll R = 0, cR = 0;
	ll B = 0, cB = 0;
	for (int i = 0; i < n; ++i)
	{
		cin >> x[i] >> m[i] >> c[i];
		if (c[i] == 'R')
		{
			R += x[i] * m[i];
			cR += m[i];
		}
		if (c[i] == 'B')
		{
			B += x[i] * m[i];
			cB += m[i];
		}
	}

	if (R >= B)
	{
		// R not loose
		bool draw = false;
		if (cB >= cR)
		{
			draw = true;
		}

		ll bb = n - 1;
		ll rb = n - 1;
		ll sumR = 0, sumB = 0;
		ll cntR = 0, cntB = 0;
		while (bb >= 0)
		{
			while (bb >= 0 && c[bb] == 'R')
			{
				--bb;
			}
			if (bb < 0)
			{
				break;
			}
			cntB += m[bb];
			sumB += m[bb] * x[bb];
			bb--;
			while (cntR < cntB)
			{
				while (rb >= 0 && c[rb] == 'B')
				{
					--rb;
				}
				if (rb < 0)
				{
					draw = true;
					break;
				}
				if (m[rb] > cntB - cntR)
				{
					sumR += (cntB - cntR) * x[rb];
					m[rb] -= (cntB - cntR);
					cntR = cntB;
					break;
				}
				else
				{
					sumR += m[rb] * x[rb];
					cntR += m[rb];
					m[rb] = 0;
					--rb;
				}
			}
			if (sumB > sumR + 1)
			{
				draw = true;
				break;
			}
		}

		ll xx = -1;
		for (int i = 0; i < n; ++i)
		{
			if (c[i] == 'R')
			{
				xx = x[i];
			}
		}
		if (draw)
		{
			cout << "Draw " << xx << " +" << endl;
			return;
		}
		else
		{
			cout << "First " << xx << " +" << endl;
		}
	}
	else
	{
		// B not loose
		bool draw = false;

		if (cR >= cB)
		{
			draw = true;
		}

		ll bb = n - 1;
		ll rb = n - 1;
		ll sumR = 0, sumB = 0;
		ll cntR = 0, cntB = 0;
		while (rb >= 0)
		{
			while (rb >= 0 && c[rb] == 'B')
			{
				--rb;
			}
			if (rb < 0)
			{
				break;
			}
			cntR += m[rb];
			sumR += m[rb] * x[rb];
			rb--;
			while (cntB < cntR)
			{
				while (bb >= 0 && c[bb] == 'R')
				{
					--bb;
				}
				if (bb < 0)
				{
					draw = true;
					break;
				}
				if (m[bb] > cntR - cntB)
				{
					sumB += (cntR - cntB) * x[bb];
					m[bb] -= (cntR - cntB);
					cntB = cntR;
					break;
				}
				else
				{
					sumB += m[bb] * x[bb];
					cntB += m[bb];
					m[bb] = 0;
					--bb;
				}
			}
			if (sumR > sumB)
			{
				draw = true;
				break;
			}
		}

		ll xx = -1;
		for (int i = 0; i < n; ++i)
		{
			if (c[i] == 'R')
			{
				xx = x[i];
			}
		}
		if (draw)
		{
			cout << "Draw " << xx << " +" << endl;
			return;
		}
		else
		{
			cout << "Second" << endl;
		}
	}
}

