#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdint>

using namespace std;

void solve() {
    int64_t n;
    cin >> n;
    vector<pair<int64_t, int64_t>> a(n);
    for (int64_t i = 0; i < n; ++i) {
        cin >> a[i].first;
    }
    for (int64_t i = 0; i < n; ++i) {
        cin >> a[i].second;
    }
    sort(a.begin(), a.end());
    int64_t ans = 0;
    int64_t cnt = 0;
    for (int64_t i = 0; i < n; ++i) {
        if (a[i].first > a[i].second - cnt) {
            cout << -1 << '\n';
            return;
        }
        int64_t d = (a[i].second - cnt) - a[i].first;
        cnt += d;
        ans += d;
    }
    cout << ans << '\n';
}

int main() {
    int64_t t;
    cin >> t;
    while (t--) {
        solve();
    }
}