#include <bits/stdc++.h>

using namespace std;

vector<int> top, used;
vector<vector<int>> g;

void topsort(int v) {
    used[v] = 1;
    for (int u: g[v]) {
        if (!used[u])
            topsort(u);
    }
    top.push_back(v);
}

int main() {
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        g.clear();
        used.clear();
        top.clear();
        g.resize(n + 1);
        used.resize(n + 1);
        vector<pair<int, int>> ed(m);
        for (int i = 0; i < m; ++i) {
            int u, v;
            cin >> u >> v;
            g[u].push_back(v);
            ed[i] = {u, v};
        }
        for (int i = 1; i <= n; ++i) {
            if (!used[i]) {
                topsort(i);
            }
        }
        reverse(top.begin(), top.end());
        vector<int> order(n + 1);
        for (int i = 0; i < n; ++i) {
            order[top[i]] = i;
        }
        int c = 0;
        for (int i = 0; i < m; ++i) {
            int u = ed[i].first;
            int v = ed[i].second;
            if (order[u] > order[v]) {
                c++;
            }
        }
        if (c > m / 2) {
            reverse(top.begin(), top.end());
        }
        for (int i = 0; i < n; ++i) {
            cout << top[i] << ' ';
        }
        cout << '\n';
    }
}