from random import randint

for _ in range(int(input())):
    n = int(input())
    mountains_now = list(map(int, input().split()))
    mountains_before = list(map(int, input().split()))

    # n = randint(1, 6)
    # mountains_now = [randint(1, 100_000) for _ in range(n)]
    # mountains_before = [elem + randint(0, 6) for elem in mountains_now]
    
    diffs = [mountains_before[i] - mountains_now[i] for i in range(len(mountains_now))]
    
    # Проверка на корректность
    if any([diff < 0 for diff in diffs]):
        print(-1)
        continue

    d = sorted([[mountains_now[i], mountains_before[i], diffs[i]] for i in range(len(mountains_before))], key=lambda x: (x[-1], x[0], x[1]))
    
    mountains_now = [elem[0] for elem in d]
    mountains_before = [elem[1] for elem in d]
    diffs = [elem[-1] for elem in d]
    
    if mountains_now != sorted(mountains_now) or mountains_before != sorted(mountains_before) or diffs != sorted(diffs):
        print(-1)
        continue
    
    # Горы точно уменьшаются в правильном порядке
    print(max(diffs))
    