#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef vector<ll> vi;

#define pb push_back
#define forn(i, n) for(ll i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()

void solve(){
    int n;
    cin >> n;

    vector<ll> a(n);
    forn(i, n) {
        cin >> a[i];
    }

    if (n == 2) {
        if (abs(a[0] - a[1]) > min(a[0], a[1])) {
            cout << "0\n";
        } else {
            cout << min(a[0], a[1]) - abs(a[0] - a[1]) << "\n";
        }
        return;
    }

    // diff[i] = a[i] - a[i - 1]
    vector<ll> diff(n);
    set<pair<ll, ll>, greater<pair<ll, ll>>> q;

    auto push = [&](auto i) {
        if (i.first) {
            q.insert(i);
        }
    };

    forn(i, n) {
        diff[i] = a[i] - a[(i + n - 1) % n];
        push(pair<ll, ll>{diff[i], i});
    }


    auto get = [&](int i) {
        return pair<ll, ll>(diff[(i + n) % n], (i + n) % n);
    };

    // apply -1 -1 2
    vector<ll> op(n);
    int i = 0;
    ll add = 0;

    while (q.size() > 2) {
        // for (auto it : diff) {
        //     cout << it << " ";
        // }
        // cout << endl;

        // if (was.size() == 2) {
        //     cout << "0\n";
        //     return;
        // }

        // cout << q.begin()->first << endl;
        
        auto val = diff[i];
        auto cnt = abs(val);
    
        if (val == 0) {
            continue;
        }
        q.erase(get(i));
        q.erase(get(i + 1));
        q.erase(get(i + 2));

        if (val < 0) {
            // applied to center 
            op[i] -= cnt;
            add += cnt;
            
            diff[i] += cnt;
            diff[(i + n + 1) % n] += cnt;
            diff[(i + n + 2) % n] -= 2 * cnt;
        } else if (val > 0) {
            // applied to center 
            op[(i + n - 1) % n] += cnt;
            
            diff[i] -= cnt;
            diff[(i + n + 1) % n] -= cnt;
            diff[(i + n + 2) % n] += 2 * cnt;
        }

        push(get(i));
        push(get(i + 1));
        push(get(i + 2));
        
        i = (i + 1) % n;
    }

    if (q.size() == 2) {
        cout << "0\n";
        return;
    }

    forn(i, n) {
        op[i] += add;
    }
    auto top = *min_element(all(op));
    // for (auto it : op) {
    //     cout << it << "  " << endl;
    // }
    
    forn(i, n) {
        op[i] -= top;
    }

    auto sub = op[0] * 2 + op[n - 1];
    cout << max(0LL, a[0] - sub) << "\n";    
}

int main(){
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
    int t = 1;
    cin >> t;
    while (t--)
    {
        solve();
    }
}