#include <iostream>
#include <vector>
#include "algorithm"
using namespace std;

typedef long long ll;
bool c(pair<int,int> a, pair<int,int> b){
    return a.second>b.second;
}
void solve() {
    ll n;
    cin>>n;
    vector<pair<int,int>> hp(n);
    for (int i = 0; i < n; ++i) {
        cin>>hp[i].first;
    }
    for (int i = 0; i < n; ++i) {
        cin>>hp[i].second;
    }
    sort(hp.begin(), hp.end(), c);
    vector<int> raz(n);

    bool ansExist = true;
    for (int i = 0; i < n; ++i) {
        raz[i] = hp[i].second- hp[i].first;
        if (raz[i]<0){
            ansExist = false;
            break;
        }
        if (i>0){
            if (raz[i]>raz[i-1]){
                ansExist = false;
                break;
            }
        }

    }
    if (!ansExist){
        cout<<-1<<'\n';
        return;
    }
    ll t = 0;
    ll last = -1;
    ll ans = 0;
    for (int i = n-1; i>=0; --i) {
        if (last == raz[i]) continue;
        ll k = raz[i] - t;
        ans+=k;
        t+=k;
        last = raz[i];
    }
    cout<<ans<<'\n';
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int t = 1; cin >> t;
    while (t--) solve();
    return 0;
}
