import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int n = scanner.nextInt();
        int min = 1000;
        int prev = 0;
        int index = n;
        int matches = 0;
        boolean spam = false;
        int maxDelay = 10;
        while (n > 0){
            n--;
            String time = scanner.next();
            int num = convert(time);
            if(min == 1000){
                min = 999;
                prev = num;
                continue;
            }
            int difference = num - prev;
            min = Math.min(difference, min);
            prev = num;
            if(difference < maxDelay){
                maxDelay -= difference;
                matches++;
                if(matches >= 2) spam = true;
            }
            else {
                maxDelay = 10;
                matches = 0;
                if(difference < maxDelay) {
                    maxDelay -= difference;
                    matches++;
                }
            }
        }
        if(spam) System.out.println(0);
        else {
            if(min <= 10) System.out.println(1);
            else System.out.println(2);
        }
    }

    private static int convert(String time){
        int hours = Integer.parseInt(time.split(":")[0]);
        int minute = Integer.parseInt(time.split(":")[1]);
        return hours * 60 + minute;
    }
}