#include <iostream>
#include <algorithm>
#include <vector>
#include <map>

using namespace std;

#define int long long
int md = 998244353;
int bp(int a, int st){
    if(st == 0)
        return 1;
    if(st == 1)
        return a;
    int aa = a * a % md;
    return bp(aa, st / 2) * bp(a, st % 2) % md;
}

vector<pair<pair<int, int>, int>> cuts;
map<int, int> other;

void solve() {
    int n;
    cin >> n;
    int d[n];
    int c[n];
    int sd = 0;
    for (int i = 0; i < n; i++) {
        cin >> c[i];
        if (i != 0) {
            d[i] = c[i] - c[i-1];
            sd += d[i];
        }
    }
    d[0] = c[0] - c[n-1];
    sd += d[0];
    if (sd != 0) {
        cout << 0 << "\n";
        return;
    }
    bool flag = true;
    for (int ik = 1; ik <= 10000000000; ik*=2) {
        for (int i = 0; i < n; i++) {
            if (d[i] < 0) {
                int k = (-d[i]) / 2 + (-d[i] % 2);
                c[(i-1+n)%n] -= k * 2;
                c[(i-2+n)%n] -= k;
            }
        }
        flag = true;
        bool flag_min0 = true;
        for (int i = 0; i < n; i++) {
            if (i != 0) {
                d[i] = c[i] - c[i-1];
                if (d[i] != 0) {
                    flag = false;
                }
            }
            if (c[i] < 0) {
                flag_min0 = false;
                break;
            }
        }
        d[0] = c[0] - c[n-1];
        if (flag) {
            break;
        }
        if (!flag_min0) {
            break;
        }
    }
    if (flag && c[0] > 0) {
        cout << c[0] << "\n";
    } else {
        cout << 0 << "\n";
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie();
    int t;
    cin >> t;
    while (t > 0) {
        t--;
        solve();
    }
    return 0;
}
