#include <bits/stdc++.h>

using namespace std;

#define int long long

const int mod = 998244353;

int n;
vector<int> a, b;
vector<long long> f;

long long up(int i, int c, const vector<int> &a) {
	if (i == -1)
		return 0;
	if (c == a[i])
		return up(i - 1, a[i], a);
	if (i == 0)
		return abs(a[i] - c);
	if (abs(a[i] - c) == 1)
		return (up(i, a[i], a) + 3 * f[i - 1] + 1) % mod;
	return (up(i, a[i], a) + 4 * f[i - 1] + 2) % mod;
}

long long up(int i, int c) {
	return up(i, c, a);
}

long long down(int i, int c) {
	return up(i, c, b);
}

void solve() {
	cin >> n;
	a.resize(n);
	for (int &i : a) {
		cin >> i;
		i--;
	}
	b.resize(n);
	for (int &i : b) {
		cin >> i;
		i--;
	}
	if (a == b) {
		cout << "0\n";
		return;
	}
	f.resize(n);
	f[0] = 1;
	for (int i = 1; i < n; i++)
		f[i] = (3 * f[i - 1] + 1) % mod;

	int i = n - 1;
	while (a[i] == b[i])
		i--;
	int c = 3 - a[i] - b[i];
	long long ans;
	if (abs(a[i] - b[i]) == 1) {
		ans = up(i - 1, c) + down(i - 1, c) + 1;
	} else {
		long long f_i = 0;
		if (i > 0)
			f_i = f[i - 1];
		ans = up(i - 1, c) + f_i * 3 + down(i - 1, a[i]) + 2;
	}
	ans %= mod;
	cout << ans << "\n";
}

int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int T = 1;
	cin >> T;
	while (T--) {
		solve();
	}
	return 0;
}