#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;

const ll maxn = ll(2e5)+5;
const ll mod = 988244353;

ll binpow(ll n, ll a) {
    if (a == 0) return 1;
    if (a%2) return n*binpow(n, a-1)%mod;
    ll t = binpow(n, a/2);
    return t*t%mod;
}

void solve() {
    ll n,k;
    cin >> n >> k;
    vector<string> s(n);
    for (int i=0;i<n;++i) cin >> s[i];
    vector<bool> ok(k, 1);
    for (int i=0;i<n;++i) {
        set<char> uniq;
        for (auto e: s[i]) uniq.insert(e);
        if (uniq.size() == 1) {
            ok[*uniq.begin()-'a']=0;
        }
    }
    ll ans = ll(2e9);
    string b_ans;
    for (int i=0;i<k;++i) {
       if (!ok[i]) continue;
       string cur;
       for (int j=0;j<n;++j) {
            for (auto e: s[j]) {
                if (e != char('a'+i)) break;
                cur += e;
            }
       }
       cur += char('a'+i);
       if (cur.size() < ans) {
            ans = cur.size();
            b_ans = cur;
       }
    }
    if (ans == ll(2e9)) {
        cout << "NO\n";
        return;
    }
    cout << b_ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    
    ll t;
    t=1;
    while (t--) solve();
    return 0;
}