import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;

public class Main {
    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        int t = in.nextInt();
        for (int i = 0; i < t; i++) {
            int n = in.nextInt();
            long red = 0;
            long blue = 0;
            int redL = Integer.MAX_VALUE;
            int redR = Integer.MIN_VALUE;
            int blueL = Integer.MAX_VALUE;
            int blueR = Integer.MIN_VALUE;
            Set<Integer> redExist = new HashSet<>();
            for (int j = 0; j < n; j++) {
                int x = in.nextInt();
                int cnt = in.nextInt();
                char color = in.next().charAt(0);
                if (color == 'R') {
                    red += cnt;
                    redL = Math.min(redL, x);
                    redR = Math.max(redR, x);
                    redExist.add(x);
                } else {
                    blue += cnt;
                    blueL = Math.min(blueL, x);
                    blueR = Math.max(blueR, x);
                }
            }
            if (red == blue) {
                System.out.println("Draw " + redL + " +");
            } else if (red > blue) {
                if (blue == 1) {
                    if (redR > blueL) {
                        System.out.println("First " + redL + " +"); // blue is trapped whatever we do
                    } else if (redExist.contains(blueL - 1)) {
                        System.out.println("First " + (blueL - 1) + " +"); // only winning move
                    } else {
                        System.out.println("Draw " + redL + " +"); // blue escapes whatever we do
                    }
                } else if (blueR > redR) {
                    System.out.println("Draw " + redL + " +"); // blue escapes to the right whatever we do
                } else {
                    System.out.println("First " + redL + " +"); // blue is trapped whatever we do
                }
            } else {
                if (redR > blueR) {
                    System.out.println("Draw " + redR + " +"); // escape to the right
                } else {
                    System.out.println("Second");
                }
            }
        }
    }
}