#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <numeric>

using namespace std;

void solve() {
    long long n, m;
    std::cin >> n >> m;
    std::vector<long long> in(n + 1, 0), out(n + 1, 0);
    for (int i = 0, u, v; i < m; ++i) {
        std::cin >> u >> v;
        out[u]++;
        in[v]++;
    }
    std::vector<long long> vec(n);
    iota(vec.begin(), vec.end(), 1ll);
    std::sort(vec.begin(), vec.end(), [&](int a, int b) {
        return (out[a] > in[a] ? -out[a] : in[a]) < (out[b] > in[b] ? -out[b] : in[b]);
    });
    for (auto u : vec) {
        std::cout << u << ' ';
    }
}



int main() {
    cin.tie(0)->sync_with_stdio(false);
    int tests = 1; cin >> tests;
    while (tests--) {
        solve();
        cout << '\n';
    }
}