// #pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("Ofast", "O3")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx,avx2")
#include "bits/stdc++.h"

using namespace std;

using ll = long long;

int a[200000];
int d[200000];

void solve()
{
    int n;
    cin >> n;
    

    for(int i = 0; i < n; ++i)
    {
        cin >> a[i];
    }

    set<pair<int, int>> st;

    for(int i = 0; i < n; ++i)
    {
        d[i] = -a[(i + 1) % n] + a[i];
        st.insert({d[i], i});
    }

    int v = 0;
    int k = 0;
    while(true)
    {
        auto [x, i] = (*st.rbegin());
        if(x == 0)
        {
            break;
        }
        v = i;

        ll buf = d[v] / 2 + d[v] % 2;


        st.erase({d[v], v});
        st.erase({ d[(v + n-1) % n], (v + n-1) % n});
        st.erase({d[(v + n-2) % n], (v + n-2) % n});
        d[v] -= 2 * buf;
        d[(v + n-1) % n] += buf;
        d[(v + n-2) % n] += buf;

        st.insert({d[v], v});
        st.insert({d[(v + n-1) % n], (v + n-1) % n});
        st.insert({d[(v + n-2) % n], (v + n-2) % n});

        a[v] -= 2 * buf;
        a[(v + n - 1) % n] -= buf;

        if(a[v] <= 0 || a[(v + n - 1) % n] <= 0)
        {
            cout << "0\n";
            return;
        }

        
    }

    cout << a[0] << '\n';
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t;
    cin >> t;
    for(int i = 0; i < t; ++i)
    {
        solve();
    }
}