//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC optimize("O3,unroll-loops")
//#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt"
//#pragma GCC target("avx2,avx,sse2,sse")

#define _GLIBCXX_DEBUG 1

#include <bits/stdc++.h>
using namespace std;
#define int long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define Sz(x) ((int)(x).size())
#define rep(i, a, b) for(int i = a; i < (b); ++i)
using ld = long double;
[[maybe_unused]] constexpr static int INF = (int) 1e18+10+300+5251+14154;
using pii = pair<int, int>;
using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vpi = vector<pii>;
#ifdef LOCAL
void debugPrint(long long integer) {cerr << integer;}
void debugPrint(float kek) {cerr << kek;}
void debugPrint(double kek) {cerr << kek;}
void debugPrint(std::string s) {cerr << "\"" << s << "\"";}
void debugPrint(const char* s) {cerr << "\"" << s << "\"";}
void debugPrint(bool b) {cerr << (b ? "true" : "false");}
void debugPrint(char  c) {cerr << "\'" << c << "\'";}
template <typename F, typename S>
void debugPrint(const pair<F, S> & p) { cerr << "{"; debugPrint(p.first); cerr << ", "; debugPrint(p.second); cerr << "}";}
template<typename T>
void debugPrint(complex<T> c) { cerr << "{"; debugPrint(c.real()); cerr << ", "; debugPrint(c.imag()); cerr << "}";}
template <template <typename> class Container, typename T>
void debugPrint(Container<T>& container) {
    cerr << "{";
    for (auto it = container.begin(); it != container.end(); ++it) {
        if (it == container.begin()) {
            debugPrint(*it);
        } else {
            cerr << ", ";
            debugPrint(*it);
        }
    }
    cerr << "}";
}
void debugPrint() {}
template <typename Head, typename... Tail>
void debugPrint(Head head, Tail... tail) {
    debugPrint(head); if (sizeof...(tail) != 0) {
        cerr << ", ";
    }
    debugPrint(tail...);
}
#endif
#ifdef LOCAL
#define debug(x...) cerr << "[" << #x << "] = ["; debugPrint(x); cerr << "]\n";
#else
#define debug(x...) 52
#endif

void solve() {
    const int MOD = 998244353;
    int n, m, k;
    cin >> n >> m >> k;
    string kek; cin >> kek;

    auto good = [&] (string s, string w) {
        for (int i = 0; i + Sz(w) - 1 < Sz(s); i++) {
            if (s.substr(i, Sz(w)) == w) {
                return false;
            }
        }
        return true;
    };
    auto calc_dp = [&] (const string& w) -> vvi {
        vi ans(101, 0);
        vvi dp(101, vi(1 << Sz(w), 0));

        for (int len = 0; len < Sz(w); len++) {
            ans[len] = (1ll << len);
        }
        for (int len = Sz(w); len <= 7; len++) {
            for (int i = 0; i < (1LL << len); i++) {
                string s;
                for (int j = 0; j < len; j++) {
                    if (i & (1 << j)) {
                        s+='1';
                    }else{
                        s+='0';
                    }
                }
//                if (good(s, w)) {
//                    debug("goood");
//                }
                dp[len][i % (1<<Sz(w))] += good(s, w);
            }
            ans[len] = accumulate(all(dp[len]), 0LL) % MOD;
        }

        debug(ans[Sz(w)]);

        for (int len = 8; len <= 100; len++) {

            for (int mask1 = 0; mask1 < (1<<Sz(w)); mask1++) {
                for (int mask2 = 0; mask2 < (1<<Sz(w)); mask2++) {
                    string s;
                    for (int j = 0; j < Sz(w); j++) s+=(char)('0' + (mask1 & (1 << j)));
                    for (int j = 0; j < Sz(w); j++) s+=(char)('0' + (mask2 & (1 << j)));

                    if (!good(s, w)) continue;
//                    debug(mask1, mask2);
                    dp[len][mask2] += dp[len - Sz(w)][mask1];
                    dp[len][mask2] %= MOD;
                }
            }

            ans[len] = accumulate(all(dp[len]), 0LL) % MOD;
        }
        return dp;
    };

    auto dp = calc_dp(kek);
//    for (int i = 0; i <= 0; i++) {
//        for (int j = 0; j < (1<<Sz(kek)); j++) {
//            dp[i][j] = 1;
//        }
//    }

//    for (int i = 0; i < 10; i++) {
//        cout << dp[i] << " ";
//    }

    vector<int> pow(1001, 1);
    for (int i = 1; i <= 1000; i++) {
        pow[i] = (2 * pow[i - 1]) % MOD;
    }

    int ans = 0;

    auto got = [&] (int e) -> int {
        if (e < Sz(kek)) return (1 << e);

        int tiktok = 0;
        for (int mask = 0; mask < (1 << Sz(kek)); mask++) {
            string s;
            for (int j = 0; j < Sz(kek); j++) s += (char) ('0' + (mask & (1 << j)));
            s += kek;
            s.pop_back();
            if (good(s, kek)) {
                tiktok+=dp[e - Sz(kek)][mask];
            }
        }
        return tiktok;
    };
    for (int i = 0; i <= 10; i++) {
        debug(i, got(i));
    }
    for (int e1 = Sz(kek); e1 <= n; e1++) {
        for (int e2 = Sz(kek); e2 <= m; e2++) {
            int anothers1 = n - e1;
            int anothers2 = m - e2;
            int mult = pow[anothers1] * pow[anothers2] % MOD;

            auto t1 = got(e1);
            auto t2 = got(e2);
            int cur = t1 * t2 % MOD;
            cur *= mult;
            cur %= MOD;
            ans+=cur;
            ans %= MOD;
        }
    }
    cout << ans << endl;
}
const int modulo = 998244353;
vector<int> prec(1e5 * 2);

void precH() {
    prec[0] = 0;
    prec[1] = 1;
    for (int i = 2; i < prec.size(); ++i) {
        prec[i] = (3 * prec[i - 1] + 1) % modulo;
    }
}

void solveH() {
    int n;
    cin >> n;
    vector<int> a(n);
    vector<int> b(n);
    for(int& i : a) cin >> i;
    for(int& i : b) cin >> i;
    vector<vector<int >> dp(n, vector<int>(3, INF));

    if (a[0] == 1) {
        dp[0] = {0, 1, 2};
    } else if(a[0] == 2) {
        dp[0] = {1, 0, 1};
    } else if(a[0] == 3) {
        dp[0] = {2, 1, 0};
    } else {
        assert(false);
    }

    for (int i = 1; i < n; ++i) {
        if (a[i] == 1) {
            dp[i] = {dp[i - 1][0], (dp[i - 1][2] + 1 + prec[i]) % modulo, (dp[i - 1][2] + 1 + prec[i] * 4 + 1) % modulo};
        } else if (a[i] == 2) {
            dp[i] = {(dp[i - 1][2] + 1 + prec[i] * 2) % modulo, dp[i - 1][1], (dp[i - 1][0] + 1 + prec[i] * 2) % modulo};
        } else if (a[i] == 3) {
            dp[i] = {(dp[i-1][0] + prec[i] * 4 + 1) % modulo, (dp[i - 1][0] + 1 + prec[i]) % modulo, dp[i - 1][2]};
        }
    }
    int last = -1;
    int ans = 0;
    for (int i = n - 1; i >= 0; --i) {
        if (b[i] != a[i]) {
            last = i;
            break;
        }
    }
    if (last == -1) {
        cout << 0 << endl;
        return;
    }

    if (last == 0) {
        if (b[0] == 2 || a[0] == 2) {
            cout << 1 << endl;
            return;
        }
        cout << 2 << endl;
        return;
    }

    assert(a[last] != b[last]);

    int all_colour;

    if (a[last] == 1) {
        if (b[last] == 2) {
            ans = (dp[last - 1][0] + 1) % modulo;
            all_colour = 3;
        } else if (b[last] == 3) {
            ans = (dp[last - 1][2] + 1 + prec[last] * 2 + 1) % modulo;
            all_colour = 1;
        }
    } else if (a[last] == 3) {
        if (b[last] == 2) {
            ans = (dp[last - 1][2] + 1) % modulo;
            all_colour = 1;
        } else if (b[last] == 1) {
            ans = (dp[last - 1][0] + 1 + prec[last] * 2 + 1) % modulo;
            all_colour = 3;
        }
    } else { // a = 2
        if (b[last] == 1) {
            ans = (dp[last - 1][2] + 1);
            all_colour = 3;
        } else {
            ans = (dp[last - 1][0] + 1);
            all_colour = 1;
        }
    }

//    cout << dp[0][0] << ' ' << dp[0][1] << ' ' << dp[0][2] << '\n';
//    cout << dp[1][0] << ' ' << dp[1][1] << ' ' << dp[1][2] << '\n';
//    cout << dp[2][0] << ' ' << dp[2][1] << ' ' << dp[2][2] << '\n';
//--last;
//    cout << last << ' ' << all_colour << ' ' << ans << "\n";

    for (int i = last - 1; i>= 0; --i) {
        if (b[i] == all_colour) continue;
        if (all_colour == 1) {
            if (b[i] == 2) {
                ans += prec[i] * 2 + 1;
                all_colour = 3;
            } else {
                ans += prec[i] * 4 + 2;
                all_colour = 1;
            }
        } else if (all_colour == 3) {
            if (b[i] == 2) {
                ans += prec[i] * 2 + 1;
                all_colour = 1;
            } else {
                ans += prec[i] * 4 + 2;
                all_colour = 3;
            }
        } else {
            if (b[i] == 1) {
                ans += prec[i] + 1;
                all_colour = 3;
            } else {
                ans += prec[i] + 1;
                all_colour = 1;
            }
        }

        ans %= modulo;

//        cout << i << ' ' << ans << "\n";
    }

    cout << ans << endl;


}

constexpr int MOD = 1e9 + 7;

int bpow(int a, int n) {
    if (n == 0) {
        return 1;
    }
    a = a % MOD;
    if (n == 1) {
        return a % MOD;
    }
    int b = bpow(a, n / 2);
    b = (b * b) % MOD;
    if (n % 2 == 1) {
        b *= a;
        b %= MOD;
    }
    return b;
}

void solveBebra() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto& i : a) {
        cin >> i;
    }

    auto check = [&](int k) -> bool {
        vector<int> t(n);
        for (int i = 0; i < n; ++i) {
            if (a[i] < k) {
               return false;
            }
            t[i] = a[i] - k;
        }
        int inv2 = bpow(2, MOD - 2);
        int cur2 = 1;
        int tsum = 0;
        for (int i = 0; i < n; ++i) {
            int sgn = 1;
            if (i % 2 == 1) sgn = -1;
            tsum += (sgn * t[i] * cur2) % MOD;
            tsum %= MOD;
            cur2 *= inv2;
        }
        int denom = (1 + ((n + 1) % 2 == 0 ? 1 : -1) * cur2) % MOD;
        int y1 = tsum * bpow(denom, MOD - 2);
        y1 %= MOD;
        vector<int> x(n);
        x[0] = (y1 * inv2) % MOD;
        for (int i = 1; i < n; ++i) {
            x[i] = t[i - 1] - 2 * x[i - 1];
            x[i] %= MOD;
        }
        for (int i = 0; i < n; ++i) {
            x[i] += MOD;
            x[i] %= MOD;
        }
        for (int i = 0; i < n; ++i) {
            if (2 * x[i] + x[(i + 1) % n] != t[i]) {
                return false;
            }
        }
        return true;

    };


    int ans = 0;
    for (int ost = 0; ost < 3; ++ost) {
        int l = 0;
        int r = 1e9;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            int k = 3 * mid + ost;
            if (check(k)) {
                l = mid;
            } else {
                r = mid;
            }
        }
        if (check(l)) {
            ans = max(ans, l);
        }
    }
    cout << ans << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    freopen("C:\\work\\vologda\\input.txt", "r", stdin);
#endif

    precH();

    int cnt;
    cin >> cnt;
    while(cnt--) {
//        solveBebra();
        solveH();
    }
    return 0;

}