const int MOD = 998'244'353;
const int INF = 1e9;
const long long INFLL = 1e18;
#include <bits/stdc++.h>
using namespace std;
#ifdef LOCAL
#define dbg(x) cerr << __LINE__ << " " << #x << " " << x << endl
#define ln cerr << __LINE__ << " fine, thanks" << endl
#else
#define dbg(x) void(0)
#define ln void(0)
#endif 
int cx[4] = { -1, 0, 1, 0 };
int cy[4] = { 0, -1, 0, 1 };
string Yes[2] = { "No\n", "Yes\n" };
string YES[2] = { "NO\n", "YES\n" };
string Possible[2] = { "Impossible\n", "Possible\n" };
string POSSIBLE[2] = { "IMPOSSIBLE\n", "POSSIBLE\n" };
template <const int mod = MOD>
struct modint {
	int val;
	modint() {
		val = 0;
	}
	modint(int x) {
		if (x < 0 || x >= mod)
			x = x % mod;
		if (x < 0)
			x += mod;
		val = x;
	}
	modint(long long x) {
		if (x < 0 || x >= mod)
			x = x % mod;
		if (x < 0)
			x += mod;
		val = x;
	}
	inline modint<mod> operator+=(const modint<mod>& other) {
		val += other.val;
		if (val >= mod)
			val -= mod;
		return *this;
	}
	inline modint<mod> operator-=(const modint<mod>& other) {
		val -= other.val;
		if (val < 0)
			val += mod;
		return *this;
	}
	inline modint<mod> operator*=(const modint<mod>& other) {
		val = 1ll * val * other.val % mod;
		return *this;
	}
	inline modint<mod> operator/=(const modint<mod>& other) {
		*this *= inv(other);
		return *this;
	}
	inline bool operator==(const modint<mod>& other) {
		return val == other.val;
	}
};
template <const int mod>
inline modint<mod> operator+(modint<mod> x, const modint<mod>& y) {
	x += y;
	return x;
}
template <const int mod>
inline modint<mod> operator+(modint<mod> x, const long long& y) {
	x += y;
	return x;
}
template <const int mod>
inline modint<mod> operator+(const long long& x, modint<mod> y) {
	y += x;
	return y;
}
template <const int mod>
inline modint<mod> operator-(modint<mod> x, const modint<mod>& y) {
	x -= y;
	return x;
}
template <const int mod>
inline modint<mod> operator-(modint<mod> x, const long long& y) {
	x -= y;
	return x;
}
template <const int mod>
inline modint<mod> operator-(const long long& x, const modint<mod>& y) {
	return modint<mod>(x - y.val);
}
template <const int mod>
inline modint<mod> operator*(modint<mod> x, const modint<mod>& y) {
	x *= y;
	return x;
}
template <const int mod>
inline modint<mod> operator*(modint<mod> x, const long long& y) {
	x *= y;
	return x;
}
template <const int mod>
inline modint<mod> operator*(const long long& x, modint<mod> y) {
	y *= x;
	return y;
}
template <const int mod>
inline modint<mod> binpow(const modint<mod>& x, long long d) {
	modint<mod> res = 1, f = x;
	while (d >= 1) {
		if (d % 2) res *= f;
		f *= f;
		d /= 2;
	}
	return res;
}
template <const int mod>
inline modint<mod> inv(const modint<mod>& x) {
	return binpow(x, mod - 2);
}
template <const int mod>
inline modint<mod> operator/(modint<mod> x, const modint<mod>& y) {
	x /= y;
	return x;
}
template <const int mod>
inline modint<mod> operator/(modint<mod> x, const long long& y) {
	x /= y;
	return x;
}
template <const int mod>
inline modint<mod> operator/(const long long& x, const modint<mod>& y) {
	return (modint<mod>(x) / y);
}
template <const int mod>
istream& operator>>(istream& in, modint<mod>& a) {
	in >> a.val;
	return in;
}
template <const int mod>
ostream& operator<<(ostream& out, const modint<mod>& a) {
	out << a.val;
	return out;
}
inline long long binpow(long long x, long long d, long long mod) {
	long long res = 1 % mod, f = x % mod;
	while (d >= 1) {
		if (d % 2) res = res * f % mod;
		f = f * f % mod;
		d /= 2;
	}
	return res;
}
const int _ifact_limit = 5e6;
template <const int mod = MOD>
struct _ifact_storage_ {
	vector<modint<mod> > fact, ifact, inv;
	inline void touch(int n) {
		if (n < 2) n = 2;
		if (fact.size() > size_t(n)) return;
		int pn = fact.size();
		fact.resize(n); ifact.resize(n); inv.resize(n);
		if (pn == 0) {
			inv[1] = 1;
			fact[0] = 1;
			fact[1] = 1;
			ifact[0] = 1;
			ifact[1] = 1;
			pn = 2;
		}
		for (int i = pn; i < n; i++) {
			inv[i] = mod - inv[mod % i] * (mod / i);
			fact[i] = fact[i - 1] * i;
			ifact[i] = ifact[i - 1] * inv[i];
		}
	}
};
_ifact_storage_<MOD> _ifact_storage;
template <const int mod = MOD>
inline modint<mod> fact(const int& n, _ifact_storage_<mod> & st = _ifact_storage) {
	st.touch(n + 1);
	return st.fact[n];
}
template <const int mod = MOD>
inline modint<mod> invmem(const int& n, _ifact_storage_<mod> & st = _ifact_storage) {
	st.touch(n + 1);
	return st.inv[n];
}
template <const int mod = MOD>
inline modint<mod> ifact(const int& n, _ifact_storage_<mod> & st = _ifact_storage) {
	st.touch(n + 1);
	return st.ifact[n];
}
template <const int mod = MOD>
inline modint<mod> cnk2(const int& n, int k, _ifact_storage_<mod> & st = _ifact_storage) {
	modint<mod> res = 1;
	k = min(k, n - k);
	for (int i = 1; i <= k; i++) {
		res *= (n + 1 - i);
		if (i < _ifact_limit)
			res *= invmem(i, st);
		else
			res /= i;
	}
	return res;
}
template <const int mod = MOD>
inline modint<mod> cnk(const int& n, const int& k, _ifact_storage_<mod> & st = _ifact_storage) {
	if (k < 0 || k > n)
		return 0;
	if (n > _ifact_limit)
		return cnk2(n, k, st);
	st.touch(n + 1);
	return fact(n, st) * ifact(k, st) * ifact(n - k, st);
}
struct _intbinary_storage_ {
	_intbinary_storage_() {
		lower_upper_bitcount = (short*)malloc(S * sizeof(short));
		bitreverse = (int*)malloc(S * sizeof(int));
		lower_upper_bitcount[0] = 0;
		bitreverse[0] = 0;
		for (int i = 1; i < S; i++) {
			int l = -1, u = 0, bc = 0;
			int br = 0;
			for (int j = 0; j < B; j++) {
				br = 2 * br;
				if (i & (1 << j)) {
					bc++;
					u = j;
					if (l == -1) l = j;
					br++;
				}
			}
			lower_upper_bitcount[i] = short(l + (u << 4) + (bc << 8));
			bitreverse[i] = br;
		}
	}
	static const int B = 16;
	static const int S = (1 << B);
	short* lower_upper_bitcount;
	int* bitreverse;
	_intbinary_storage_(_intbinary_storage_&&) = delete;
	_intbinary_storage_(const _intbinary_storage_&) = delete;
	inline int lowerbit(const int& x) const {
		return lower_upper_bitcount[x] & 15;
	}
	inline int upperbit(const int& x) const {
		return (lower_upper_bitcount[x] & 255) >> 4;
	}
	inline int bitcount(const int& x) const {
		return lower_upper_bitcount[x] >> 8;
	}
	friend int lowerbit(const int& x);
	friend int upperbit(const int& x);
	friend int bitcount(const int& x);
	friend int bitreverse(const int& x, const int& len);
};
const _intbinary_storage_ _intbinary_storage;
int lowerbit(const int& x) {
	if (x & (_intbinary_storage.S - 1))
		return _intbinary_storage.lowerbit(x & (_intbinary_storage.S - 1));
	return _intbinary_storage.lowerbit(x >> _intbinary_storage.B)
		+ _intbinary_storage.B;
}
int upperbit(const int& x) {
	if (x >= _intbinary_storage.S)
		return _intbinary_storage.upperbit(x >> _intbinary_storage.B)
		+ _intbinary_storage.B;
	return _intbinary_storage.upperbit(x);
}
int bitcount(const int& x) {
	return _intbinary_storage.bitcount(x >> _intbinary_storage.B)
		+ _intbinary_storage.bitcount(x & (_intbinary_storage.S - 1));
}
int bitreverse(const int& x, const int& len) {
	if (len <= _intbinary_storage.B)
		return _intbinary_storage.bitreverse[x << (_intbinary_storage.B - len)];
	int fr = len - _intbinary_storage.B;
	int low = _intbinary_storage.bitreverse[x >> fr];
	int high = _intbinary_storage.bitreverse[x & ((1 << fr) - 1)] >> (_intbinary_storage.B - fr);
	return low + (high << _intbinary_storage.B);
}
const int fft_cutoff = 250;
template <const int mod = MOD>
struct fft_runner {
	fft_runner(fft_runner&&) = delete;
	fft_runner(const fft_runner&) = delete;
	int mxsz;
	modint<mod>** pw;
	pair<int, int> find_g() {
		int mxsz = 0;
		int z = mod - 1;
		while (z % 2 == 0) z /= 2, mxsz++;
		mxsz = min(mxsz, 20);
		for (int i = 3; ; i += 2) {
			int x = i;
			int fl = 1;
			for (int j = 0; j < mxsz - 1; j++) {
				x = 1ll * x * x % mod;
				if (x == 1) {
					fl = 0;
					break;
				}
			}
			x = 1ll * x * x % mod;
			if (fl == 1 && x == 1)
				return { mxsz, i };
		}
	}
	fft_runner() {
		pair<int, int> prec = find_g();
		mxsz = prec.first;
		modint<mod> g = prec.second;
		modint<mod> inv_g = inv(g);
		pw = (modint<mod> * *)malloc(2 * sizeof(modint<mod>*));
		pw[0] = (modint<mod>*)malloc((1 << mxsz) * sizeof(modint<mod>));
		pw[1] = (modint<mod>*)malloc((1 << mxsz) * sizeof(modint<mod>));
		pw[0][0] = 1, pw[1][0] = 1;
		for (int i = 1; i < (1 << mxsz); i++)
			pw[0][i] = pw[0][i - 1] * g, pw[1][i] = pw[1][i - 1] * inv_g;
	}
	void dft(vector<modint<mod> >& a, int fl, int lg) const {
		for (size_t i = 0; i < a.size(); i++) {
			size_t br = bitreverse(i, lg);
			if (i < br)
				swap(a[i], a[br]);
		}
		modint<mod> v, u;
		for (size_t len = 2, deep = mxsz - 1; len <= a.size(); len <<= 1, deep--) {
			for (size_t i = 0; i < a.size(); i += len) {
				for (size_t j = 0; j < len / 2; j++) {
					v = a[i + j], u = a[i + j + len / 2] * pw[fl][j << deep];
					a[i + j] = v + u;
					a[i + j + len / 2] = v - u;
				}
			}
		}
	}
	vector<modint<mod> > fft(vector<modint<mod> >& a, vector<modint<mod> > b) const {
		int deg = a.size() + b.size() - 1;
		if (deg <= fft_cutoff || a.size() <= 3 || b.size() <= 3) {
			vector<modint<mod> > ans(deg);
			for (size_t i = 0; i < a.size(); i++) {
				for (size_t j = 0; j < b.size(); j++) {
					ans[i + j] += a[i] * b[j];
				}
			}
			a = ans;
			return a;
		}
		int lg = upperbit(deg);
		int sz = (1 << lg);
		if (sz < deg) sz <<= 1, lg++;
		assert(lg <= lowerbit(mod - 1) && "degree of polynomials is too high for this modulo");
		assert(lg <= 20 && "degree of polynomials is larger than pow(2, 20)");
		a.resize(sz);
		b.resize(sz);
		dft(a, 0, lg);
		dft(b, 0, lg);
		for (int i = 0; i < sz; i++)
			a[i] *= b[i];
		dft(a, 1, lg);
		modint<mod> q = inv(modint<mod>(sz));
		for (int i = 0; i < sz; i++)
			a[i] *= q;
		a.resize(deg);
		return a;
	}
};
template <const int mod = MOD>
struct poly {
	inline static const fft_runner<mod> run;
	inline static _ifact_storage_<mod> _poly_ifact_storage;
	vector<modint<mod> > a;
	poly(const vector<modint<mod> >& _a) {
		a = _a;
	}
	poly(const vector<int>& _a) {
		a.resize(_a.size());
		for (size_t i = 0; i < a.size(); i++) {
			a[i] = _a[i];
		}
	}
	poly(const vector<long long>& _a) {
		a.resize(_a.size());
		for (size_t i = 0; i < a.size(); i++) {
			a[i] = _a[i];
		}
	}
	poly(const initializer_list<int>& _b) {
		vector<int> _a = _b;
		a.resize(_a.size());
		for (size_t i = 0; i < a.size(); i++) {
			a[i] = _a[i];
		}
	}
	poly(const initializer_list<long long>& _b) {
		vector<long long> _a = _b;
		a.resize(_a.size());
		for (size_t i = 0; i < a.size(); i++) {
			a[i] = _a[i];
		}
	}
	inline poly operator+=(const poly& other) {
		a.resize(max(a.size(), other.a.size()));
		for (size_t i = 0; i < other.a.size(); i++) {
			a[i] += other.a[i];
		}
		return *this;
	}
	inline poly operator-=(const poly& other) {
		a.resize(max(a.size(), other.a.size()));
		for (size_t i = 0; i < other.a.size(); i++) {
			a[i] -= other.a[i];
		}
		return *this;
	}
	inline poly operator*=(const poly& other) {
		run.fft(a, other.a);
		return *this;
	}
	inline poly cut(const size_t& n) {
		a.resize(n);
		return *this;
	}
};
template <const int mod>
inline poly<mod> operator+(poly<mod> x, const poly<mod>& y) {
	x += y;
	return x;
}
template <const int mod>
inline poly<mod> operator-(poly<mod> x, const poly<mod>& y) {
	x -= y;
	return x;
}
template <const int mod>
inline poly<mod> operator*(poly<mod> x, const poly<mod>& y) {
	x *= y;
	return x;
}
template <const int mod>
inline poly<mod> copycut(poly<mod> a, const size_t& n) {
	a.cut(n);
	return a;
}
template <const int mod>
inline poly<mod> inv(const poly<mod>& a, const size_t& n) {
	poly<mod> b{ 1 };
	b.a[0] = inv(a.a[0]);
	size_t sz = 1;
	while (sz < n) {
		b *= ((copycut(a, 2 * sz) * b).cut(2 * sz) - poly<mod>{2});
		b.cut(2 * sz);
		for (size_t i = 0; i < b.a.size(); i++) b.a[i] = mod - b.a[i];
		sz <<= 1;
	}
	b.cut(n);
	return b;
}
template <const int mod>
inline poly<mod> deriv(const poly<mod>& a) {
	poly<mod> b{ 1 };
	b.a.resize(a.a.size() - 1);
	for (size_t i = 0; i + 1 < a.a.size(); i++) {
		b.a[i] = a.a[i + 1] * (int(i) + 1);
	}
	return b;
}
template <const int mod>
inline poly<mod> integr(const poly<mod>& a) {
	poly<mod> b{ 0 };
	b.a.resize(a.a.size() + 1);
	for (size_t i = 0; i < a.a.size(); i++) {
		b.a[i + 1] = a.a[i] * invmem(i + 1, poly<mod>::_poly_ifact_storage);
	}
	return b;
}
template <const int mod>
inline poly<mod> lg(const poly<mod>& a, const size_t& n) {
	fact(int(n) + 1);
	return integr((deriv(a) * inv(a, n)).cut(n - 1));
}
template <const int mod>
inline poly<mod> exp(const poly<mod>& a, const size_t& n) {
	fact(int(n) + 1);
	poly<mod> b{ 1 };
	size_t sz = 1;
	while (sz < n) {
		b *= (copycut(a, 2 * sz) - lg(b, 2 * sz) + poly<mod>{1});
		b.cut(2 * sz);
		sz <<= 1;
	}
	b.cut(n);
	return b;
}
template <const int mod>
inline pair<poly<mod>, poly<mod> > divmod(poly<mod>& a, poly<mod>& b, int need_rem = 1) {
	if (a.a.size() < b.a.size()) {
		if (!need_rem)
			return { poly{0}, poly{0} };
		else
			return { poly{0}, poly{a} };
	}
	reverse(a.a.begin(), a.a.end());
	reverse(b.a.begin(), b.a.end());
	int n = a.a.size() - b.a.size();
	poly<mod> q = (inv(b, n + 1) * copycut(a, n + 1)).cut(n + 1);
	reverse(a.a.begin(), a.a.end());
	reverse(b.a.begin(), b.a.end());
	reverse(q.a.begin(), q.a.end());
	if (!need_rem)
		return { q, poly{0} };
	else
		return { q, (a - q * b).cut(b.a.size() - 1) };
}
template <const int mod>
inline vector<modint<mod> > evaluate(poly<mod>& a, const vector<modint<mod> >& points) {
	int sz = 1;
	while (sz < points.size()) sz <<= 1;
	vector<poly<mod> > t(2 * sz, poly<mod>{1});
	for (int i = 0; i < int(points.size()); i++) {
		t[sz + i] = poly<mod>({ mod - points[i], 1 });
	}
	for (int i = sz - 1; i > 0; i--) {
		t[i] = t[2 * i] * t[2 * i + 1];
	}
	t[1] = divmod(a, t[1]).second;
	for (int i = 2; i < sz + int(points.size()); i++) {
		t[i] = divmod(t[i / 2], t[i]).second;
	}
	vector<modint<mod> > res(points.size());
	for (int i = 0; i < int(points.size()); i++) {
		res[i] = t[i + sz].a[0];
	}
	return res;
}
template <const int mod>
inline poly<mod> interpolate(const vector<modint<mod> >& x, const vector<modint<mod> >& y) {
	int sz = 1;
	while (sz < x.size()) sz <<= 1;
	vector<poly<mod> > t(2 * sz, poly{ 1 });
	for (int i = 0; i < int(x.size()); i++) {
		t[sz + i] = poly<mod>({ mod - x[i], 1 });
	}
	for (int i = sz - 1; i > 0; i--) {
		t[i] = t[2 * i] * t[2 * i + 1];
	}
	poly<mod> p = deriv(t[1]);
	vector<modint<mod> > s = evaluate(p, x);
	vector<poly<mod> > f(2 * sz, poly{ 0 });
	for (int i = 0; i < int(x.size()); i++) {
		f[sz + i] = poly<mod>({ y[i] / s[i] });
	}
	for (int i = sz - 1; i > 0; i--) {
		f[i] = f[2 * i] * t[2 * i + 1] + f[2 * i + 1] * t[2 * i];
	}
	return f[1].cut(x.size());
}
template <const int mod>
inline poly<mod> interpolate(const vector<int> x, const vector<int> y) {
	assert(x.size() == y.size());
	int n = x.size();
	vector<pair<int, int> > v;
	vector<modint<mod> > X, Y;
	for (int i = 0; i < n; i++) {
		v.push_back({ x[i] % mod, y[i] });
	}
	sort(v.begin(), v.end());
	X.push_back(v[0].first), Y.push_back(v[0].second);
	for (int i = 1; i < n; i++) {
		if (v[i].first == v[i - 1].first) {
			assert(v[i].second == v[i - 1].second);
		}
		else {
			X.push_back(v[i].first), Y.push_back(v[i].second);
		}
	}
	return interpolate(X, Y);
}
template <const int mod>
ostream& operator<<(ostream& out, const poly<mod>& a) {
	out << "[";
	for (size_t i = 0; i < a.a.size(); i++)
		out << a.a[i] << " ]"[i + 1 == a.a.size()];
	return out;
}
template <typename T>
struct SumF {
	virtual inline T f(const T& x, const T& y) {
		return x + y;
	}
};
template <typename T>
struct MaxF {
	virtual inline T f(const T& x, const T& y) {
		if (x > y) return x;
		return y;
	}
};
template <typename T>
struct MinF {
	virtual inline T f(const T& x, const T& y) {
		if (x < y) return x;
		return y;
	}
};
template <typename T>
struct MaxCF {
	virtual inline T f(const T& x, const T& y) {
		if (x.first > y.first)
			return x;
		if (x.first < y.first)
			return y;
		return { x.first, x.second + y.second };
	}
};
template <typename T>
struct MinCF {
	virtual inline T f(const T& x, const T& y) {
		if (x.first < y.first)
			return x;
		if (x.first > y.first)
			return y;
		return { x.first, x.second + y.second };
	}
};
template <typename T>
struct AddF {
	virtual inline void f(T& x, const T& y) {
		x += y;
	}
};
template <typename T>
struct SetF {
	virtual inline void f(T& x, const T& y) {
		x = y;
	}
};
template <typename T>
struct SumAddCompF {
	virtual inline void f(T& x, const T& y, const int& k) {
		x += y * k;
	}
};
template <typename T>
struct MaxAddCompF {
	virtual inline void f(T& x, const T& y, const int& k) {
		x += y;
	}
};
template <typename T>
struct MinAddCompF {
	virtual inline void f(T& x, const T& y, const int& k) {
		x += y;
	}
};
template <typename T>
struct SumSetCompF {
	virtual inline void f(T& x, const T& y, const int& k) {
		x = y * k;
	}
};
template <typename T>
struct MaxSetCompF {
	virtual inline void f(T& x, const T& y, const int& k) {
		x = y;
	}
};
template <typename T>
struct MinSetCompF {
	virtual inline void f(T& x, const T& y, const int& k) {
		x = y;
	}
};
struct DefaultRandomF {
	inline uint32_t f() {
		uint32_t x = rand();
		uint32_t y = rand();
		return (x << 15) + y;
	}
};
template <typename T, typename MergeF, typename UpdateF>
struct BottomUpSegTree : protected MergeF, protected UpdateF {
	T* t;
	T def;
	int sz;
	BottomUpSegTree(int _sz, T _def) {
		sz = 1;
		def = _def;
		while (sz < _sz) sz <<= 1;
		t = new T[2 * sz];
		for (int i = 2 * sz - 1; i >= 0; i--) t[i] = def;
	}
	BottomUpSegTree(T _def, vector<T>& elems) {
		sz = 1;
		def = _def;
		while (sz < (int)elems.size()) sz <<= 1;
		t = new T[2 * sz];
		for (int i = sz - 1; i >= int(elems.size()); i--) t[i + sz] = def;
		for (int i = int(elems.size()) - 1; i >= 0; i--) t[i + sz] = elems[i];
		for (int i = sz - 1; i >= 1; i--) t[i] = MergeF::f(t[2 * i], t[2 * i + 1]);
	}

	~BottomUpSegTree() {
		delete[] t;
	}
	inline void Update(int pos, T val) {
		pos += sz;
		UpdateF::f(t[pos], val);
		while (pos > 1) {
			pos /= 2;
			t[pos] = MergeF::f(t[2 * pos], t[2 * pos + 1]);
		}
	}
	inline T Get(int l, int r) {
		l += sz, r += sz;
		T accumLeft = def, accumRight = def;
		while (l <= r) {
			if (l % 2 == 1)
				accumLeft = MergeF::f(accumLeft, t[l]), l++;
			if (l <= r && r % 2 == 0)
				accumRight = MergeF::f(t[r], accumRight), r--;
			l /= 2, r /= 2;
		}
		return MergeF::f(accumLeft, accumRight);
	}
	inline T Get(int pos) {
		return Get(pos, pos);
	}
	inline int DepleteToRight(int l, T target) {
		l += sz;
		T accum = def;
		int comp = accum < target;
		while (l > 0) {
			T x = MergeF::f(accum, t[l]);
			if ((x < target) == comp) {
				accum = x;
				if (((l + 1) & l) == 0) return sz;
				if (l % 2 == 0) l++;
				else l = l / 2 + 1;
			}
			else break;
		}
		if (l == 0) return sz;
		while (l < sz) {
			T x = MergeF::f(accum, t[2 * l]);
			if ((x < target) == comp) {
				accum = x;
				l = 2 * l + 1;
			}
			else {
				l = 2 * l;
			}
		}
		return l - sz;
	}
	inline int DepleteToLeft(int r, T target) {
		r += sz;
		T accum = def;
		int comp = accum < target;
		while (r > 0) {
			T x = MergeF::f(t[r], accum);
			if ((x < target) == comp) {
				accum = x;
				if ((r & (r - 1)) == 0) return -1;
				if (r % 2 == 1) r--;
				else r = r / 2 - 1;
			}
			else break;
		}
		if (r == 0) return -1;
		while (r < sz) {
			T x = MergeF::f(t[2 * r + 1], accum);
			if ((x < target) == comp) {
				accum = x;
				r = 2 * r;
			}
			else {
				r = 2 * r + 1;
			}
		}
		return r - sz;
	}
};
template <typename T, template<typename> typename MergeF, template<typename> typename UpdateF>
using segtree = BottomUpSegTree<T, MergeF<T>, UpdateF<T> >;
template <typename T, typename MergeF, typename LazyF>
struct LazySegTree : protected MergeF, protected LazyF {
	T* t;
	T def, nouse;
	int sz;
	T* push;
	LazySegTree(int _sz, T _def, T _nouse) {
		def = _def;
		nouse = _nouse;
		sz = _sz;
		t = new T[4 * sz];
		push = new T[4 * sz];
		for (int i = 0; i < 4 * sz; i++) t[i] = def, push[i] = nouse;
	}
	LazySegTree(T _def, T _nouse, vector<T>& elems) {
		def = _def;
		nouse = _nouse;
		sz = elems.size();
		t = new T[4 * sz];
		push = new T[4 * sz];
		for (int i = 0; i < 4 * sz; i++) t[i] = def;
		Build(0, sz, 0, elems);
		for (int i = 0; i < 4 * sz; i++) push[i] = nouse;
	}

	~LazySegTree() {
		delete[] t;
		delete[] push;
	}
	inline void Push(int V, int L, int M, int R) {
		if (push[V] != nouse) {
			LazyF::f(t[2 * V + 1], push[V], M - L);
			LazyF::f(t[2 * V + 2], push[V], R - M);
			if (push[2 * V + 1] != nouse) LazyF::f(push[2 * V + 1], push[V], 1);
			else push[2 * V + 1] = push[V];
			if (push[2 * V + 2] != nouse) LazyF::f(push[2 * V + 2], push[V], 1);
			else push[2 * V + 2] = push[V];
			push[V] = nouse;
		}
	}
	inline void Build(int L, int R, int V, vector<T>& elems) {
		if (L + 1 == R) {
			t[V] = elems[L];
			return;
		}
		int M = (L + R) / 2;
		Build(L, M, 2 * V + 1, elems);
		Build(M, R, 2 * V + 2, elems);
		t[V] = MergeF::f(t[2 * V + 1], t[2 * V + 2]);
	}
	inline void Update(int l, int r, T val, int L, int R, int V) {
		if (l <= L && R <= r) {
			if (push[V] != nouse) LazyF::f(push[V], val, 1);
			else push[V] = val;
			LazyF::f(t[V], val, R - L);
			return;
		}
		int M = (L + R) / 2;
		Push(V, L, M, R);
		if (l <= L && M <= r) {
			if (push[2 * V + 1] != nouse) LazyF::f(push[2 * V + 1], val, 1);
			else push[2 * V + 1] = val;
			LazyF::f(t[2 * V + 1], val, M - L);
		}
		else if (l < M) Update(l, r, val, L, M, 2 * V + 1);
		if (l <= M && R <= r) {
			if (push[2 * V + 2] != nouse) LazyF::f(push[2 * V + 2], val, 1);
			else push[2 * V + 2] = val;
			LazyF::f(t[2 * V + 2], val, R - M);
		}
		else if (M < r) Update(l, r, val, M, R, 2 * V + 2);
		t[V] = MergeF::f(t[2 * V + 1], t[2 * V + 2]);
	}
	inline T Get(int l, int r, int L, int R, int V) {
		if (l <= L && R <= r) return t[V];
		int M = (L + R) / 2;
		if (L + 1 != R) Push(V, L, M, R);
		if (r <= M) return Get(l, r, L, M, 2 * V + 1);
		if (M <= l) return Get(l, r, M, R, 2 * V + 2);
		return MergeF::f(Get(l, r, L, M, 2 * V + 1), Get(l, r, M, R, 2 * V + 2));
	}
	inline pair<int, T> DepleteToRight(int l, T accum, T target, int L, int R, int V) {
		if (R <= l) return { sz, def };
		if (l <= L) {
			T x = MergeF::f(accum, t[V]);
			if ((x < target) == (accum < target))
				return { sz, x };
			if (L + 1 == R)
				return { L, x };
		}
		int M = (L + R) / 2;
		Push(V, L, M, R);
		pair<int, T> A = DepleteToRight(l, accum, target, L, M, 2 * V + 1);
		if (A.first != sz) return A;
		return DepleteToRight(l, A.second, target, M, R, 2 * V + 2);
	}
	inline pair<int, T> DepleteToLeft(int r, T accum, T target, int L, int R, int V) {
		if (r <= L) return { -1, def };
		if (R <= r) {
			T x = MergeF::f(t[V], accum);
			if ((x < target) == (accum < target))
				return { -1, x };
			if (L + 1 == R)
				return { L, x };
		}
		int M = (L + R) / 2;
		Push(V, L, M, R);
		pair<int, T> A = DepleteToLeft(r, accum, target, M, R, 2 * V + 2);
		if (A.first != -1) return A;
		return DepleteToLeft(r, A.second, target, L, M, 2 * V + 1);
	}
	inline void Update(int l, int r, T val) {
		Update(l, r + 1, val, 0, sz, 0);
	}
	inline void Update(int pos, T val) {
		Update(pos, pos + 1, val, 0, sz, 0);
	}
	inline T Get(int l, int r) {
		return Get(l, r + 1, 0, sz, 0);
	}
	inline T Get(int pos) {
		return Get(pos, pos + 1, 0, sz, 0);
	}
	inline int DepleteToRight(int l, T target) {
		pair<int, T> comp = DepleteToRight(l, def, target, 0, sz, 0);
		return comp.first;
	}
	inline int DepleteToLeft(int r, T target) {
		pair<int, T> comp = DepleteToLeft(r + 1, def, target, 0, sz, 0);
		return comp.first;
	}
};
template <typename T, template<typename> typename MergeF, template<typename> typename LazyF>
using lazysegtree = LazySegTree<T, MergeF<T>, LazyF<T> >;
template <typename T, typename RangeDS, typename MergeF>
struct VertexHLD : protected MergeF {
	vector<int> sz, par, path, depth, slot;
	vector<RangeDS*> data;
	T def;
	VertexHLD(const vector<vector<int> >& g, const T& _def, const T& _nouse) {
		def = _def;
		Build(g);
		for (int i = 0; i < int(g.size()); i++) {
			int len = Rec(i);
			if (len) {
				data.push_back(new RangeDS(len, def, _nouse));
			}
		}
	}
	VertexHLD(const vector<vector<int> >& g, const T& _def, const vector<T>& vals) {
		def = _def;
		Build(g);
		vector<T> elems;
		for (int i = 0; i < int(g.size()); i++) {
			if (Rec(i, elems, vals)) {
				data.push_back(new RangeDS(def, elems));
			}
		}
	}
	VertexHLD(const vector<vector<int> >& g, const T& _def, const T& _nouse, const vector<T>& vals) {
		def = _def;
		Build(g);
		vector<T> elems;
		for (int i = 0; i < int(g.size()); i++) {
			if (Rec(i, elems, vals)) {
				data.push_back(new RangeDS(def, _nouse, elems));
			}
		}
	}

	inline void Update(int v, const T& val) {
		data[slot[v]]->Update(depth[v] - depth[path[v]], val);
	}
	inline void Update(int fr, int to, const T& val) {
		while (path[fr] != path[to]) {
			if (depth[path[fr]] > depth[path[to]]) {
				data[slot[fr]]->Update(0, depth[fr] - depth[path[fr]], val);
				fr = par[path[fr]];
			}
			else {
				data[slot[to]]->Update(0, depth[to] - depth[path[to]], val);
				to = par[path[to]];
			}
		}
		if (depth[to] > depth[fr]) {
			data[slot[to]]->Update(depth[fr] - depth[path[fr]], depth[to] - depth[path[to]], val);
		}
		else {
			data[slot[fr]]->Update(depth[to] - depth[path[to]], depth[fr] - depth[path[fr]], val);
		}
	}
	inline T Get(int fr, int to) {
		T accum = def;
		while (path[fr] != path[to]) {
			if (depth[path[fr]] > depth[path[to]]) {
				accum = MergeF::f(accum, data[slot[fr]]->Get(0, depth[fr] - depth[path[fr]]));
				fr = par[path[fr]];
			}
			else {
				accum = MergeF::f(accum, data[slot[to]]->Get(0, depth[to] - depth[path[to]]));
				to = par[path[to]];
			}
		}
		if (depth[to] > depth[fr]) {
			accum = MergeF::f(accum, data[slot[to]]->Get(depth[fr] - depth[path[fr]], depth[to] - depth[path[to]]));
		}
		else {
			accum = MergeF::f(accum, data[slot[fr]]->Get(depth[to] - depth[path[to]], depth[fr] - depth[path[fr]]));
		}
		return accum;
	}
	inline void Build(const vector<vector<int> >& g) {
		sz.resize(g.size(), 1);
		par.resize(g.size(), -1);
		path.resize(g.size(), -1);
		depth.resize(g.size(), -1);
		slot.resize(g.size(), -1);
		vector<int> q = { 0 };
		vector<int> pnt = { 0 };
		depth[0] = 0;
		while (q.size()) {
			int ind = q.size() - 1;
			int v = q[ind];
			if (pnt[ind] < g[v].size() && g[v][pnt[ind]] == par[v]) {
				pnt[ind]++;
			}
			if (pnt[ind] == g[v].size()) {
				if (par[v] != -1) {
					sz[par[v]] += sz[v];
					if (path[par[v]] == -1 || sz[v] > sz[path[par[v]]]) {
						path[par[v]] = v;
					}
				}
				q.pop_back();
				pnt.pop_back();
				continue;
			}
			par[g[v][pnt[ind]]] = v;
			depth[g[v][pnt[ind]]] = depth[v] + 1;
			q.push_back(g[v][pnt[ind]]);
			pnt.push_back(0);
			pnt[ind]++;
		}
	}
	inline bool Rec(int v, vector<T>& elems, const vector<T>& vals) {
		if (slot[v] != -1) return false;
		if (v != 0 && slot[par[v]] == -1 && path[par[v]] == v) return false;
		vector<int> q = { v };
		while (path[q.back()] != -1) {
			q.push_back(path[q.back()]);
		}
		elems.clear();
		for (int i = 0; i < int(q.size()); i++) {
			elems.push_back(vals[q[i]]);
			slot[q[i]] = data.size();
			path[q[i]] = q[0];
		}
		return true;
	}
	inline int Rec(int v) {
		if (slot[v] != -1) return 0;
		if (v != 0 && slot[par[v]] == -1 && path[par[v]] == v) return 0;
		int len = 1, sv = v;
		while (path[v] != -1) {
			int tmp = path[v];
			len++;
			slot[v] = data.size();
			path[v] = sv;
			v = tmp;
		}
		slot[v] = data.size();
		path[v] = sv;
		return len;
	}
};
template <typename T, template<typename, typename, typename> typename SegTree, template<typename> typename MergeF, template<typename> typename UpdateFOrLazyF>
using pathdecomp = VertexHLD<T, SegTree<T, MergeF<T>, UpdateFOrLazyF<T> >, MergeF<T> >;
struct CentroidDecomposition {
	vector<int> level, par;
	CentroidDecomposition(vector<vector<int> >& g) {
		int n = g.size();
		g.resize(n);
		level.resize(n);
		par.resize(n);
		Build(0, -1, 1, g);
	}
	vector<vector<int> > GetDistsTable(vector<vector<int> >& g) {
		vector<vector<int> > res(g.size());
		for (size_t i = 0; i < g.size(); i++) {
			res[i].resize(level[i]);
		}
		vector<int> dist(g.size()), tm(g.size(), -1);
		vector<int> q;
		for (size_t i = 0; i < g.size(); i++) {
			q = { int(i) };
			dist[i] = 0;
			tm[i] = i;
			for (size_t j = 0; j < q.size(); j++) {
				res[q[j]][level[q[j]] - level[i]] = dist[q[j]];
				for (auto u : g[q[j]]) {
					if (level[u] > level[i] && tm[u] < tm[i]) {
						tm[u] = i;
						dist[u] = dist[q[j]] + 1;
						q.push_back(u);
					}
				}
			}
		}
		return res;
	}
	int GetSz(int v, int p, vector<vector<int> >& g) {
		int res = 1;
		for (auto u : g[v]) {
			if (level[u] == 0 && u != p) {
				res += GetSz(u, v, g);
			}
		}
		return res;
	}
	int FindCentroid(int v, int p, int& c, int sz, vector<vector<int> >& g) {
		int res = 1;
		for (auto u : g[v]) {
			if (level[u] == 0 && u != p) {
				res += FindCentroid(u, v, c, sz, g);
			}
		}
		if (2 * res >= sz && c == -1) {
			c = v;
		}
		return res;
	}
	void Build(int v, int p, int lev, vector<vector<int> >& g) {
		int c = -1;
		int sz = GetSz(v, p, g);
		FindCentroid(v, p, c, sz, g);
		level[c] = lev;
		par[c] = p;
		for (auto u : g[c]) {
			if (level[u] == 0) {
				Build(u, c, lev + 1, g);
			}
		}
	}
};
template <typename T>
vector<int> ZFunc(const T& s) {
	vector<int> z(s.size());
	z[0] = s.size();
	int L = 0, R = 0;
	for (int i = 1; i < int(s.size()); i++) {
		z[i] = max(0, min(z[i - L], R - i));
		while (i + z[i] < (int)s.size() && s[i + z[i]] == s[z[i]]) z[i]++;
		if (i + z[i] > R) {
			R = i + z[i];
			L = i;
		}
	}
	return z;
}
template <typename T>
vector<int> PFunc(const T& s) {
	vector<int> p(s.size());
	for (int i = 1; i < int(s.size()); i++) {
		int j = p[i - 1];
		while (j > 0 && s[i] != s[j])
			j = p[j - 1];
		if (s[i] == s[j])
			j++;
		p[i] = j;
	}
	return p;
}
template <typename T>
vector<int> EvenPaliFunc(const T& s) {
	vector<int> ep(s.size());
	int L = 0, R = -1;
	for (int i = 1; i < int(s.size()); i++) {
		int k = 0;
		if (i <= R) k = min(R - i + 1, ep[R - i + L + 1]);
		while (i + k < int(s.size()) && i - k - 1 >= 0 && s[i - k - 1] == s[i + k])
			k++;
		ep[i] = k--;
		if (i + k > R) {
			L = i - k - 1;
			R = i + k;
		}
	}
	return ep;
}
template <typename T>
vector<int> OddPaliFunc(const T& s) {
	vector<int> op(s.size());
	int L = 0, R = -1;
	for (int i = 0; i < int(s.size()); i++) {
		int k = 0;
		if (i <= R) k = min(R - i + 1, op[R - i + L]);
		while (i + k < int(s.size()) && i - k >= 0 && s[i - k] == s[i + k])
			k++;
		op[i] = k--;
		if (i + k > R) {
			L = i - k;
			R = i + k;
		}
	}
	return op;
}
template <typename T>
struct Hasher {
	uint32_t base, mod;
	vector<uint32_t> powers, v;
	Hasher(const T& s, int _mod, int _base) {
		mod = _mod, base = _base;
		int n = s.size();
		powers.resize(n);
		v.resize(n);
		powers[0] = 1;
		v[0] = s[0];
		for (int i = 1; i < n; i++) {
			v[i] = (1ll * v[i - 1] * base + s[i]) % mod;
			powers[i] = 1ll * powers[i - 1] * base % mod;
		}
	}
	Hasher(const T& s) {
		mt19937 rnd(std::chrono::system_clock::now().time_since_epoch().count());
		mod = rnd() & INT_MAX;
		while (mod <= 1'000'000'000) mod = rnd() & INT_MAX;
		while (1) {
			int isp = 1;
			for (int j = 2; j * j <= mod; j++) {
				if (mod % j == 0) {
					isp = 0;
					break;
				}
			}
			if (isp) {
				break;
			}
			mod++;
		}
		base = rnd() % mod;
		while (base <= 100 || base >= mod - 100) base = rnd() % mod;
		int n = s.size();
		powers.resize(n);
		v.resize(n);
		powers[0] = 1;
		v[0] = s[0];
		for (int i = 1; i < n; i++) {
			v[i] = (1ll * v[i - 1] * base + s[i]) % mod;
			powers[i] = 1ll * powers[i - 1] * base % mod;
		}
	}
	uint32_t operator()(int l, int r) {
		if (l > r) return 0;
		uint32_t R = v[r];
		uint32_t L = l ? (1ll * v[l - 1] * powers[r - l + 1] % mod) : 0;
		return R >= L ? R - L : R + mod - L;
	}
};
template <typename T, typename MergeF>
struct SparseTable : protected MergeF {
	vector<vector<T> > sp;
	vector<int> H;
	SparseTable(const vector<T>& a) {
		int n = a.size();
		H = vector<int>(n + 1);
		for (int i = 3; i < n + 1; i++) {
			H[i] = H[i - 1] + (((i - 1) & (i - 2)) == 0);
		}
		int s = H.back() + 1;
		sp = vector<vector<T>>(s, vector<T>(n));
		for (int i = 0; i < n; i++) {
			sp[0][i] = a[i];
		}
		for (int j = 1; j < s; j++) {
			for (int i = 0; i + (1 << j) - 1 < n; i++) {
				sp[j][i] = Get(i, i + (1 << j) - 1);
			}
		}
	}
	SparseTable(T _def, const vector<T>& a) : SparseTable(a) {
	}
	inline T Get(int l, int r) {
		int h = H[r - l + 1];
		return MergeF::f(sp[h][l], sp[h][r - (1 << h) + 1]);
	}
	inline T Get(int pos) {
		return Get(pos, pos);
	}
	inline T operator()(int l, int r) {
		return Get(l, r);
	}
};
template <typename T>
using spmin = SparseTable<T, MinF<T> >;
template <typename T>
using spmax = SparseTable<T, MaxF<T> >;
template <typename RMQType>
struct LCACalculator {
	RMQType* RMQ;
	vector<int> In, Out;
	vector<pair<int, int> > EulerTour;
	void Dfs(int v, int p, const vector<vector<int> >& g, int d) {
		In[v] = Out[v] = EulerTour.size();
		EulerTour.push_back({ d, v });
		for (auto u : g[v]) if (u != p) {
			Dfs(u, v, g, d + 1);
			Out[v] = EulerTour.size();
			EulerTour.push_back({ d, v });
		}
	}
	LCACalculator(const vector<vector<int> >& g) {
		int n = g.size();
		In.resize(n);
		Out.resize(n);
		Dfs(0, -1, g, 0);
		RMQ = new RMQType({ n, n }, EulerTour);
		EulerTour.clear();
	}

	int LCA(int v, int u) {
		return RMQ->Get(min(In[v], In[u]), max(Out[v], Out[u])).second;
	}
	int Depth(int v) {
		return RMQ->Get(In[v], In[v]).first;
	}
	int Dist(int v, int u) {
		return Depth(v) + Depth(u) - 2 * Depth(LCA(v, u));
	}
};
using lca_segtree = LCACalculator<segtree<pair<int, int>, MinF, SetF> >;
using lca_sptable = LCACalculator<spmin<pair<int, int> > >;
vector<int> ConnectivityComponents(const vector<vector<int> >& graph) {
	int n = graph.size(), cnt = 0;
	vector<size_t> pnt(n);
	vector<int> res(n, -1);
	for (int i = 0; i < n; i++) {
		if (res[i] != -1) continue;
		vector<int> q = { i };
		res[i] = cnt;
		while (q.size()) {
			int v = q.back(), suc = 0;
			while (pnt[v] < graph[v].size()) {
				if (res[graph[v][pnt[v]]] == -1) {
					res[graph[v][pnt[v]]] = cnt;
					q.push_back(graph[v][pnt[v]]);
					suc = 1;
					pnt[v]++;
					break;
				}
				pnt[v]++;
			}
			if (!suc) q.pop_back();
		}
		cnt++;
	}
	return res;
}
struct GraphBridges {
	int n;
	vector<vector<int> > graph;
	vector<int> v, u, isbridge;
	vector<int> in, out, up, par, color;
	GraphBridges(int _n) {
		n = _n;
		graph.resize(n);
	}
	GraphBridges(const vector<vector<int> >& _graph) {
		n = _graph.size();
		graph.resize(n);
		for (int i = 0; i < n; i++) {
			for (size_t j = 0; j < _graph[i].size(); j++) {
				if (i < _graph[i][j]) AddEdge(i, _graph[i][j]);
			}
		}
	}
	void AddEdge(int from, int to) {
		graph[from].push_back(v.size());
		graph[to].push_back(u.size());
		v.push_back(from);
		u.push_back(to);
	}
	void MarkBridges() {
		in.resize(n, -1);
		out.resize(n, -1);
		up.resize(n, -1);
		par.resize(n, -1);
		isbridge.resize(v.size(), 0);
		int T = 0, V, U, E, suc;
		vector<size_t> pnt(n);
		for (int i = 0; i < n; i++) {
			if (in[i] != -1) continue;
			vector<int> q = { i };
			in[i] = up[i] = T++;
			while (q.size()) {
				V = q.back(), suc = 0;
				while (pnt[V] < graph[V].size()) {
					E = graph[V][pnt[V]];
					U = v[E] + u[E] - V;
					if (in[U] == -1) {
						in[U] = up[U] = T++;
						par[U] = E;
						q.push_back(U);
						suc = 1;
						pnt[V]++;
						break;
					}
					else if (E != par[V]) {
						up[V] = min(up[V], in[U]);
					}
					pnt[V]++;
				}
				if (!suc) {
					out[V] = T++;
					E = par[V];
					if (E != -1) {
						par[V] = v[E] + u[E] - V;
						up[par[V]] = min(up[par[V]], up[V]);
					}
					q.pop_back();
				}
			}
		}
		int m = v.size();
		for (int i = 0; i < m; i++) {
			if (par[u[i]] == v[i] && up[u[i]] == in[u[i]]) {
				isbridge[i] = 1;
			}
			if (par[v[i]] == u[i] && up[v[i]] == in[v[i]]) {
				isbridge[i] = 1;
			}
		}
	}
	vector<vector<int> > DLC() {
		MarkBridges();
		int T = 0, V, U, E, suc;
		vector<size_t> pnt(n);
		color.resize(n, -1);
		T = 0;
		for (int i = 0; i < n; i++) {
			if (color[i] != -1) continue;
			vector<int> q = { i };
			color[i] = T;
			while (q.size()) {
				V = q.back(), suc = 0;
				while (pnt[V] < graph[V].size()) {
					E = graph[V][pnt[V]];
					U = v[E] + u[E] - V;
					if (color[U] == -1 && !isbridge[E]) {
						color[U] = T;
						q.push_back(U);
						suc = 1;
						break;
					}
					pnt[V]++;
				}
				if (!suc) {
					q.pop_back();
				}
			}
			T++;
		}
		vector<vector<int> > res(T);
		for (int i = 0; i < n; i++) {
			res[color[i]].push_back(i);
		}
		return res;
	}
};
struct GraphArticulationPoints {
	int n;
	vector<vector<int> > graph;
	vector<int> v, u, color;
	vector<int> isAP, in, out, up, par, vis;
	GraphArticulationPoints(int _n) {
		n = _n;
		graph.resize(n);
	}
	GraphArticulationPoints(const vector<vector<int> >& _graph) {
		n = _graph.size();
		graph.resize(n);
		for (int i = 0; i < n; i++) {
			for (size_t j = 0; j < _graph[i].size(); j++) {
				if (i < _graph[i][j]) AddEdge(i, _graph[i][j]);
			}
		}
	}
	void AddEdge(int from, int to) {
		graph[from].push_back(v.size());
		graph[to].push_back(u.size());
		v.push_back(from);
		u.push_back(to);
	}
	void MarkAP() {
		in.resize(n, -1);
		out.resize(n, -1);
		up.resize(n, -1);
		par.resize(n, -1);
		isAP.resize(n, 0);
		int T = 0, rootDeg = 0;
		for (int i = 0; i < n; i++) {
			if (in[i] == -1) {
				rootDeg = 0;
				Dfs1(i, -1, T, rootDeg);
				if (rootDeg > 1)
					isAP[i] = 1;
				else
					isAP[i] = -1;
			}
		}
		for (int i = 0; i < n; i++) {
			if (isAP[i] == 0) {
				for (auto id : graph[i]) {
					int t = v[id] + u[id] - i;
					if (par[t] == i && in[i] <= up[t])
						isAP[i] = 1;
				}
			}
			else {
				if (isAP[i] == -1) {
					isAP[i] = 0;
				}
			}
		}
	}
	vector<vector<int> > Blocks() {
		MarkAP();
		color.resize(v.size(), -1);
		vis.resize(n, 0);
		int maxColor = 0;
		for (int i = 0; i < n; i++) {
			if (!vis[i]) {
				Dfs2(i, -1, maxColor, maxColor);
				maxColor++;
			}
		}
		vector<vector<int> > res(maxColor);
		for (size_t i = 0; i < v.size(); i++) {
			res[color[i]].push_back(i);
		}
		vector<vector<int> > res2;
		for (size_t i = 0; i < res.size(); i++) {
			if (res[i].size()) {
				res2.push_back(res[i]);
			}
		}
		return res2;
	}
	vector<vector<int> > VertexBlocks() {
		auto blocks = Blocks();
		vector<int> other(n, 1);
		for (auto e : blocks) {
			for (auto f : e) {
				other[v[f]] = 0;
				other[u[f]] = 0;
			}
		}
		vector<vector<int> > Res;
		for (int i = 0; i < n; i++) {
			if (other[i]) Res.push_back({ i });
			other[i] = -1;
		}
		for (int i = 0; i < int(blocks.size()); i++) {
			vector<int> res;
			for (auto e : blocks[i]) {
				if (other[v[e]] != i) res.push_back(v[e]);
				other[v[e]] = i;
				if (other[u[e]] != i) res.push_back(u[e]);
				other[u[e]] = i;
			}
			Res.push_back(res);
		}
		return Res;
	}
	void Dfs1(int V, int P, int& T, int& rootDeg) {
		par[V] = P;
		in[V] = up[V] = T++;
		for (auto id : graph[V]) {
			int t = v[id] + u[id] - V;
			if (in[t] == -1) {
				if (P == -1)
					rootDeg++;
				Dfs1(t, V, T, rootDeg);
				up[V] = min(up[V], up[t]);
			}
			else if (t != P) {
				up[V] = min(up[V], in[t]);
			}
		}
		out[V] = T++;
	}
	void Dfs2(int V, int P, int col, int& maxColor) {
		vis[V] = 1;
		for (auto id : graph[V]) {
			int t = v[id] + u[id] - V;
			if (t == P) {
				if (color[id] == -1)
					color[id] = col;
				continue;
			}
			if (!vis[t]) {
				if (up[t] >= in[V]) {
					maxColor++;
					color[id] = maxColor - 1;
					Dfs2(t, V, maxColor - 1, maxColor);
				}
				else {
					color[id] = col;
					Dfs2(t, V, col, maxColor);
				}
			}
			else {
				if (in[t] < in[V]) {
					color[id] = col;
				}
			}
		}
	}
};
struct GraphSCC {
	int n;
	vector<vector<int> > graph, igraph;
	vector<int> f, t;
	vector<int> fn;
	vector<int> vis;
	vector<int> component;
	GraphSCC(int _n) {
		n = _n;
		graph.resize(n);
		igraph.resize(n);
	}
	GraphSCC(const vector<vector<int> >& _graph) {
		n = _graph.size();
		graph.resize(n);
		igraph.resize(n);
		for (int i = 0; i < n; i++) {
			for (size_t j = 0; j < _graph[i].size(); j++) {
				AddEdge(i, _graph[i][j]);
			}
		}
	}
	void AddEdge(int from, int to) {
		graph[from].push_back(f.size());
		igraph[to].push_back(f.size());
		f.push_back(from);
		t.push_back(to);
	}
	vector<vector<int> > SCC() {
		vis.resize(n);
		component.resize(n, -1);
		fn = {};
		int col = 0;
		for (int i = 0; i < n; i++) {
			if (!vis[i]) {
				Dfs(i);
			}
		}
		reverse(fn.begin(), fn.end());
		for (auto i : fn) {
			if (component[i] == -1) {
				Dfs(i, col);
				col++;
			}
		}
		for (int i = 0; i < n; i++) {
			component[i] = col - 1 - component[i];
		}
		vector<vector<int> > res(col);
		for (int i = 0; i < n; i++) {
			res[component[i]].push_back(i);
		}
		return res;
	}
	void Dfs(int V, int col) {
		component[V] = col;
		for (auto id : graph[V]) {
			int U = t[id];
			if (component[U] == -1) {
				Dfs(U, col);
			}
		}
	}
	void Dfs(int V) {
		vis[V] = 1;
		for (auto id : igraph[V]) {
			int U = f[id];
			if (!vis[U]) {
				Dfs(U);
			}
		}
		fn.push_back(V);
	}
};
template <typename T, typename RandomF = DefaultRandomF, const bool trackSizes = true, const bool usePriorities = true, const bool isPersistent = false, const int K = 2>
struct CartesianTreeNodes {
	RandomF rnd;
	vector<uint32_t> nd_priority;
	vector<uint32_t> nd_sz;
	vector<T> nd_info;
	vector<uint32_t> nd_L, nd_R;
	CartesianTreeNodes(const uint32_t nodes_limit) {
		static_assert(trackSizes || usePriorities);
		if constexpr (usePriorities) nd_priority.reserve(nodes_limit);
		if constexpr (trackSizes) nd_sz.reserve(nodes_limit);
		nd_L.reserve(nodes_limit);
		nd_R.reserve(nodes_limit);
		nd_info.reserve(nodes_limit);
		if constexpr (usePriorities) nd_priority.resize(1);
		if constexpr (trackSizes) nd_sz.resize(1);
		nd_L.resize(1);
		nd_R.resize(1);
		nd_info.resize(1);
	}
	uint32_t GetSize(const uint32_t nd) const {
		return nd_sz[nd];
	}
	uint32_t NodeRebuildL(const uint32_t nd, const uint32_t newL) {
		if constexpr (!isPersistent) {
			nd_L[nd] = newL;
			if constexpr (trackSizes) nd_sz[nd] = GetSize(nd_L[nd]) + 1 + GetSize(nd_R[nd]);
			return nd;
		}
		else {
			if constexpr (usePriorities) nd_priority.push_back(nd_priority[nd]);
			nd_L.push_back(newL);
			nd_R.push_back(nd_R[nd]);
			if constexpr (trackSizes) nd_sz.push_back(GetSize(nd_L[nd_info.size()]) + 1 + GetSize(nd_R[nd_info.size()]));
			nd_info.push_back(nd_info[nd]);
			return nd_info.size() - 1;
		}
	}
	uint32_t NodeRebuildR(const uint32_t nd, const uint32_t newR) {
		if constexpr (!isPersistent) {
			nd_R[nd] = newR;
			if constexpr (trackSizes) nd_sz[nd] = GetSize(nd_L[nd]) + 1 + GetSize(nd_R[nd]);
			return nd;
		}
		else {
			if constexpr (usePriorities) nd_priority.push_back(nd_priority[nd]);
			nd_L.push_back(nd_L[nd]);
			nd_R.push_back(newR);
			if constexpr (trackSizes) nd_sz.push_back(GetSize(nd_L[nd_info.size()]) + 1 + GetSize(nd_R[nd_info.size()]));
			nd_info.push_back(nd_info[nd]);
			return nd_info.size() - 1;
		}
	}
	uint32_t Merge(const uint32_t L, const uint32_t R) {
		static_assert(usePriorities);
		if (!L) return R;
		if (!R) return L;
		if (nd_priority[R] > nd_priority[L]) {
			uint32_t res = Merge(L, nd_L[R]);
			return NodeRebuildL(R, res);
		}
		else {
			uint32_t res = Merge(nd_R[L], R);
			return NodeRebuildR(L, res);
		}
	}
	uint32_t MergeWithoutPriority(const uint32_t L, const uint32_t R) {
		static_assert(!usePriorities);
		static_assert(trackSizes);
		if (!L) return R;
		if (!R) return L;
		if (rnd.f() % (GetSize(L) + GetSize(R)) < GetSize(L)) {
			uint32_t res = MergeWithoutPriority(L, nd_L[R]);
			return NodeRebuildL(R, res);
		}
		else {
			uint32_t res = MergeWithoutPriority(nd_R[L], R);
			return NodeRebuildR(L, res);
		}
	}
	pair<uint32_t, uint32_t> SplitSize(const uint32_t nd, const uint32_t sz) {
		static_assert(trackSizes);
		if (!nd) return { nd, nd };
		if (sz <= GetSize(nd_L[nd])) {
			pair<uint32_t, uint32_t> res = SplitSize(nd_L[nd], sz);
			return { res.first, NodeRebuildL(nd, res.second) };
		}
		else {
			pair<uint32_t, uint32_t> res = SplitSize(nd_R[nd], sz - 1 - GetSize(nd_L[nd]));
			return { NodeRebuildR(nd, res.first), res.second };
		}
	}
	pair<uint32_t, uint32_t> SplitValue(const uint32_t nd, const T val) {
		if (!nd) return { nd, nd };
		if (val < nd_info[nd]) {
			pair<uint32_t, uint32_t> res = SplitValue(nd_L[nd], val);
			return { res.first, NodeRebuildL(nd, res.second) };
		}
		else {
			pair<uint32_t, uint32_t> res = SplitValue(nd_R[nd], val);
			return { NodeRebuildR(nd, res.first), res.second };
		}
	}
	uint32_t InsertionByPos(const uint32_t nd, const uint32_t tmp, const uint32_t pos) {
		static_assert(usePriorities);
		static_assert(trackSizes);
		if (nd == 0) {
			nd_sz[tmp] = 1;
			return tmp;
		}
		if (nd_priority[tmp] < nd_priority[nd]) {
			if (pos <= GetSize(nd_L[nd])) {
				uint32_t res = InsertionByPos(nd_L[nd], tmp, pos);
				return NodeRebuildL(nd, res);
			}
			else {
				uint32_t res = InsertionByPos(nd_R[nd], tmp, pos - GetSize(nd_L[nd]) - 1);
				return NodeRebuildR(nd, res);
			}
		}
		else {
			if (pos <= GetSize(nd_L[nd])) {
				pair<uint32_t, uint32_t> res = SplitSize(nd_L[nd], pos);
				nd_L[tmp] = res.first;
				nd_R[tmp] = NodeRebuildL(nd, res.second);
				nd_sz[tmp] = GetSize(nd_L[tmp]) + 1 + GetSize(nd_R[tmp]);
				return tmp;
			}
			else {
				pair<uint32_t, uint32_t> res = SplitSize(nd_R[nd], pos - GetSize(nd_L[nd]) - 1);
				nd_R[tmp] = res.second;
				nd_L[tmp] = NodeRebuildR(nd, res.first);
				nd_sz[tmp] = GetSize(nd_L[tmp]) + 1 + GetSize(nd_R[tmp]);
				return tmp;
			}
		}
	}
	uint32_t InsertionByPosWithoutPriority(const uint32_t nd, const uint32_t tmp, const uint32_t pos, const uint32_t depth = 1) {
		static_assert(!usePriorities);
		static_assert(trackSizes);
		if (nd == 0) {
			nd_sz[tmp] = 1;
			return tmp;
		}
		if (rnd.f() % (depth * K + GetSize(nd)) >= depth * K) {
			if (pos <= GetSize(nd_L[nd])) {
				uint32_t res = InsertionByPosWithoutPriority(nd_L[nd], tmp, pos, depth + 1);
				return NodeRebuildL(nd, res);
			}
			else {
				uint32_t res = InsertionByPosWithoutPriority(nd_R[nd], tmp, pos - GetSize(nd_L[nd]) - 1, depth + 1);
				return NodeRebuildR(nd, res);
			}
		}
		else {
			if (pos <= GetSize(nd_L[nd])) {
				pair<uint32_t, uint32_t> res = SplitSize(nd_L[nd], pos);
				nd_L[tmp] = res.first;
				nd_R[tmp] = NodeRebuildL(nd, res.second);
				nd_sz[tmp] = GetSize(nd_L[tmp]) + 1 + GetSize(nd_R[tmp]);
				return tmp;
			}
			else {
				pair<uint32_t, uint32_t> res = SplitSize(nd_R[nd], pos - GetSize(nd_L[nd]) - 1);
				nd_R[tmp] = res.second;
				nd_L[tmp] = NodeRebuildR(nd, res.first);
				nd_sz[tmp] = GetSize(nd_L[tmp]) + 1 + GetSize(nd_R[tmp]);
				return tmp;
			}
		}
	}
	uint32_t InsertionByValue(const uint32_t nd, const uint32_t tmp) {
		static_assert(usePriorities);
		if (nd == 0) {
			if constexpr (trackSizes) nd_sz[tmp] = 1;
			return tmp;
		}
		if (nd_info[tmp] == nd_info[nd]) {
			return nd;
		}
		if (nd_priority[tmp] < nd_priority[nd]) {
			if (nd_info[tmp] < nd_info[nd]) {
				uint32_t res = InsertionByValue(nd_L[nd], tmp);
				return NodeRebuildL(nd, res);
			}
			else {
				uint32_t res = InsertionByValue(nd_R[nd], tmp);
				return NodeRebuildR(nd, res);
			}
		}
		else {
			if (nd_info[tmp] < nd_info[nd]) {
				pair<uint32_t, uint32_t> res = SplitValue(nd_L[nd], nd_info[tmp]);
				nd_L[tmp] = res.first;
				nd_R[tmp] = NodeRebuildL(nd, res.second);
				if constexpr (trackSizes) nd_sz[tmp] = GetSize(nd_L[tmp]) + 1 + GetSize(nd_R[tmp]);
				return tmp;
			}
			else {
				pair<uint32_t, uint32_t> res = SplitValue(nd_R[nd], nd_info[tmp]);
				nd_R[tmp] = res.second;
				nd_L[tmp] = NodeRebuildR(nd, res.first);
				if constexpr (trackSizes) nd_sz[tmp] = GetSize(nd_L[tmp]) + 1 + GetSize(nd_R[tmp]);
				return tmp;
			}
		}
	}
	uint32_t InsertionByValueWithoutPriority(const uint32_t nd, const uint32_t tmp, const uint32_t depth = 1) {
		static_assert(!usePriorities);
		static_assert(trackSizes);
		if (nd == 0) {
			nd_sz[tmp] = 1;
			return tmp;
		}
		if (nd_info[tmp] == nd_info[nd]) {
			return nd;
		}
		if (rnd.f() % (depth * K + GetSize(nd)) >= depth * K) {
			if (nd_info[tmp] < nd_info[nd]) {
				uint32_t res = InsertionByValueWithoutPriority(nd_L[nd], tmp);
				return NodeRebuildL(nd, res);
			}
			else {
				uint32_t res = InsertionByValueWithoutPriority(nd_R[nd], tmp);
				return NodeRebuildR(nd, res);
			}
		}
		else {
			if (nd_info[tmp] < nd_info[nd]) {
				pair<uint32_t, uint32_t> res = SplitValue(nd_L[nd], nd_info[tmp]);
				nd_L[tmp] = res.first;
				nd_R[tmp] = NodeRebuildL(nd, res.second);
				if constexpr (trackSizes) nd_sz[tmp] = GetSize(nd_L[tmp]) + 1 + GetSize(nd_R[tmp]);
				return tmp;
			}
			else {
				pair<uint32_t, uint32_t> res = SplitValue(nd_R[nd], nd_info[tmp]);
				nd_R[tmp] = res.second;
				nd_L[tmp] = NodeRebuildR(nd, res.first);
				if constexpr (trackSizes) nd_sz[tmp] = GetSize(nd_L[tmp]) + 1 + GetSize(nd_R[tmp]);
				return tmp;
			}
		}
	}
	uint32_t InsertByPos(const uint32_t root, const T info, const uint32_t pos) {
		static_assert(trackSizes);
		if constexpr (usePriorities) nd_priority.push_back(rnd.f());
		nd_sz.push_back(1);
		nd_info.push_back(info);
		nd_L.push_back(0);
		nd_R.push_back(0);
		if constexpr (usePriorities) return InsertionByPos(root, nd_info.size() - 1, pos);
		if constexpr (!usePriorities) return InsertionByPosWithoutPriority(root, nd_info.size() - 1, pos);
	}
	uint32_t InsertByValue(const uint32_t root, const T info) {
		if constexpr (usePriorities) nd_priority.push_back(rnd.f());
		if constexpr (trackSizes) nd_sz.push_back(1);
		nd_info.push_back(info);
		nd_L.push_back(0);
		nd_R.push_back(0);
		if constexpr (usePriorities) return InsertionByValue(root, nd_info.size() - 1);
		if constexpr (!usePriorities) return InsertionByValueWithoutPriority(root, nd_info.size() - 1);
	}
	uint32_t EraseByPos(const uint32_t nd, uint32_t pos) {
		static_assert(trackSizes);
		uint32_t x = GetSize(nd_L[nd]);
		if (x == pos) {
			if constexpr (usePriorities) return Merge(nd_L[nd], nd_R[nd]);
			if constexpr (!usePriorities) return MergeWithoutPriority(nd_L[nd], nd_R[nd]);
		}
		if (pos <= x) {
			uint32_t res = EraseByPos(nd_L[nd], pos);
			return NodeRebuildL(nd, res);
		}
		else {
			uint32_t res = EraseByPos(nd_R[nd], pos - x - 1);
			return NodeRebuildR(nd, res);
		}
	}
	uint32_t EraseByValue(const uint32_t nd, T val) {
		if (nd == 0) {
			return nd;
		}
		if (nd_info[nd] == val) {
			if constexpr (usePriorities) return Merge(nd_L[nd], nd_R[nd]);
			if constexpr (!usePriorities) return MergeWithoutPriority(nd_L[nd], nd_R[nd]);
		}
		if (val < nd_info[nd]) {
			uint32_t res = EraseByValue(nd_L[nd], val);
			return NodeRebuildL(nd, res);
		}
		else {
			uint32_t res = EraseByValue(nd_R[nd], val);
			return NodeRebuildR(nd, res);
		}
	}
	T FindKth(uint32_t root, uint32_t pos) const {
		static_assert(trackSizes);
		while (1) {
			uint32_t x = GetSize(nd_L[root]);
			if (x == pos) {
				return nd_info[root];
			}
			if (pos <= x) {
				root = nd_L[root];
			}
			else {
				pos -= x + 1;
				root = nd_R[root];
			}
		}
	}
	uint32_t CountLessOrEqual(uint32_t root, T val) const {
		static_assert(trackSizes);
		uint32_t res = 0;
		while (1) {
			if (root == 0) {
				return res;
			}
			uint32_t x = GetSize(nd_L[root]);
			if (nd_info[root] == val) {
				return res + x + 1;
			}
			if (val < nd_info[root]) {
				root = nd_L[root];
			}
			else {
				res += x + 1;
				root = nd_R[root];
			}
		}
	}
	bool Find(uint32_t root, T val) const {
		while (1) {
			if (root == 0) {
				return false;
			}
			if (nd_info[root] == val) {
				return true;
			}
			if (val < nd_info[root]) {
				root = nd_L[root];
			}
			else {
				root = nd_R[root];
			}
		}
	}
	uint32_t Build(const vector<T>& info, const uint32_t l, const uint32_t r) {
		if (l >= r) return 0;
		uint32_t m = (l + r) / 2, nd = nd_info.size();
		nd_info.push_back(info[m]);
		nd_L.push_back(0);
		nd_R.push_back(0);
		if constexpr (trackSizes) nd_sz.push_back(1);
		nd_L[nd] = Build(info, l, m);
		nd_R[nd] = Build(info, m + 1, r);
		if constexpr (trackSizes) nd_sz[nd] = GetSize(nd_L[nd]) + 1 + GetSize(nd_R[nd]);
		return nd;
	}
	uint32_t Build(const vector<T>& info) {
		static_assert(!usePriorities);
		if (info.size() == 0) return 0;
		return Build(info, 0, info.size());
	}
	void Traverse(const uint32_t& root, vector<T>& info) {
		if (!root) return;
		Traverse(nd_L[root], info);
		info.push_back(nd_info[root]);
		Traverse(nd_R[info], info);
	}
	void Clean() {
		if constexpr (usePriorities) nd_priority.resize(1);
		if constexpr (trackSizes) nd_sz.resize(1);
		nd_info.resize(1);
		nd_L.resize(1);
		nd_R.resize(1);
	}
	void Dealloc() {
		if constexpr (usePriorities) vector<uint32_t>().swap(nd_priority);
		if constexpr (trackSizes) vector<uint32_t>().swap(nd_sz);
		vector<T>().swap(nd_info);
		vector<uint32_t>().swap(nd_L);
		vector<uint32_t>().swap(nd_R);
	}
	void Traverse(const uint32_t nd) const {
		if (!nd) return;
		cout << "(";
		Traverse(nd_L[nd]);
		cout << ")";
		cout << "<-" << nd_info[nd] << " | " << nd_sz[nd] << "->";
		cout << "(";
		Traverse(nd_R[nd]);
		cout << ")";
	}
	void TraverseNoExtraInfo(const uint32_t nd) const {
		if (!nd) return;
		TraverseNoExtraInfo(nd_L[nd]);
		cout << nd_info[nd] << " ";
		TraverseNoExtraInfo(nd_R[nd]);
	}
	void TraverseInvoke(const uint32_t root) const {
		Traverse(root);
		cout << "\n";
	}
	void TraverseNoExtraInfoInvoke(const uint32_t root) const {
		TraverseNoExtraInfo(root);
		cout << "\n";
	}
	int Depth(const uint32_t root) const {
		if (root == 0) return 0;
		return max(Depth(nd_L[root]), Depth(nd_R[root])) + 1;
	}
};
#define forn(i, n) for (int i = 0; (i) != (n); (i)++)
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
#define popcount(x) __builtin_popcount(x)
#define popcountll(x) __builtin_popcountll(x)
#define fi first
#define se second
#define re return
#define pb push_back
#define uniq(x) sort(all(x)); (x).resize(unique(all(x)) - (x).begin())
#define safe(x, n) (0 <= (x) && (x) < (n))
#define withBit(mask, i) ((mask & (1LL << (i))) > 0)
using mint = modint<MOD>;

typedef vector<int> vi;
typedef pair<int, int> pii;

mint solve(vector<int> &a, int where, int cnt, vector<mint> &phi, vector<mint> &tau) {
    int actual_cnt = cnt;
    for (int i = cnt - 1; i >= 0; i--) {
        if (a[i] == where) {
            actual_cnt--;
        } else {
            break;
        }
    }
    if (actual_cnt == 0) {
        return 0;
    }

    int x = a[actual_cnt - 1], y = where;
    if (x == 1 && y == 2) {
        return solve(a, 3, actual_cnt - 1, phi, tau) + 1 + tau[actual_cnt - 1];
    }
    if (x == 1 && y == 3) {
        return solve(a, 3, actual_cnt - 1, phi, tau) + 1 + phi[actual_cnt - 1] + 1 + phi[actual_cnt - 1];
    }
    if (x == 2 && y == 3) {
        return solve(a, 1, actual_cnt - 1, phi, tau) + 1 + phi[actual_cnt - 1];
    }

    if (x == 2 && y == 1) {
        return solve(a, 3, actual_cnt - 1, phi, tau) + 1 + phi[actual_cnt - 1];
    }
    if (x == 3 && y == 1) {
        return solve(a, 1, actual_cnt - 1, phi, tau) + 1 + phi[actual_cnt - 1] + 1 + phi[actual_cnt - 1];
    }
    if (x == 3 && y == 2) {
        return solve(a, 1, actual_cnt - 1, phi, tau) + 1 + tau[actual_cnt - 1];
    }

    return 1 / 0;
}

void solve() {
    #define tests

    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }

    vector<mint> phi(n + 1), tau(n + 1);
    phi[1] = 2;
    tau[1] = 1;

    for (int i = 2; i <= n; i++) {
        phi[i] = 3 * phi[i - 1] + 2;
        tau[i] = phi[i - 1] + 1 + tau[i - 1];
    }

    int actual_n = n;
    for (int i = n - 1; i >= 0; i--) {
        if (a[i] == b[i]) {
            actual_n--;
        } else {
            break;
        }
    }

    if (actual_n == 0) {
        cout << 0 << "\n";
        return;
    }

    if (a[actual_n - 1] > b[actual_n - 1]) {
        swap(a, b);
    }

    int x = a[actual_n - 1], y = b[actual_n - 1];
    mint ans = 0;
    if (x == 1 && y == 2) {
        ans = solve(a, 3, actual_n - 1, phi, tau) + 1 + solve(b, 3, actual_n - 1, phi, tau);
    }
    if (x == 1 && y == 3) {
        ans = solve(a, 3, actual_n - 1, phi, tau) + 1 + phi[actual_n - 1] + 1 + solve(b, 1, actual_n - 1, phi, tau);
    }
    if (x == 2 && y == 3) {
        ans = solve(a, 1, actual_n - 1, phi, tau) + 1 + solve(b, 1, actual_n - 1, phi, tau);
    }
    cout << ans << "\n";
}


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#ifdef LOCAL
	double st = clock();
#endif 
	int t = 1;
#ifdef tests
	cin >> t;
#endif
	while (t--) {
		solve();
	}
#ifdef LOCAL
	cerr << setprecision(5) << "Succeed in " << (clock() - st) / CLOCKS_PER_SEC << " s\n";
#endif 
}
