#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int main() {
    int t; cin >> t;
    while(t--) {
        int n, m;
        cin >> n >> m;
        vector<vector<int>> g(n);
        vector<int> tin(n, 0);
        for(int i = 0; i < m; i++) {
            int x, y;
            cin >> x >> y;
            x--, y--;
            g[x].push_back(y);
            tin[y]++;
        }
        priority_queue<pair<int, int>> pq;
        for(int i = 0; i < n; i++) {
            pq.push(make_pair(-tin[i], i));
        }
        vector<bool> was(n, false);
        vector<int> order, pos(n);
        int cnt = 0;
        while(pq.size()) {
            auto x = pq.top();
            pq.pop();
            int v = x.second;
            int d = -x.first;
            if(was[v]) continue;
            was[v] = true;
            order.push_back(v);
            pos[v] = cnt++;
            for(auto i : g[v]) {
                if(!was[i]) {
                    tin[i]--;
                    pq.push(make_pair(-tin[i], i));
                }
            }
        }
        int k = 0;
        for(int i = 0; i < n; i++) {
            for(auto j : g[i]) {
                k += (pos[i] < pos[j]);
            }
        }
        if(k >= (m + 1) / 2) {
            for(auto i : order) {
                cout << i + 1 << ' ';
            }
        } else cout << -1;
        cout << '\n';
    }
    return 0;
}
