#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

const int N = 1e5 + 10;
const ll MOD = 998244353;
int arr[N], brr[N];
ll a[N], b[N];

void pre() {
    a[1] = 2; b[1] = 1;
    for (int i = 2; i < N; i++) {
        a[i] = (3 * a[i - 1] + 2) % MOD;
        b[i] = (a[i - 1] + 1 + b[i - 1]) % MOD;
    }
}

ll move_heap_from_rod(int n, int rod, int *pos) {
    while (n > 0 && pos[n - 1] == rod) {
        n--;
    }
    if (n == 0) {
        return 0;
    }
    if (rod == 0) {
        if (pos[n - 1] == 1) {
            return (a[n - 1] + 1 + move_heap_from_rod(n - 1, 2, pos)) % MOD;
        }
        if (pos[n - 1] == 2) {
            return (2 * (a[n - 1] + 1) + move_heap_from_rod(n - 1, 0, pos)) % MOD;
        }
        assert(0);
    }
    if (rod == 1) {
        if (pos[n - 1] == 0) {
            return (b[n - 1] + 1 + move_heap_from_rod(n - 1, 2, pos)) % MOD;
        }
        if (pos[n - 1] == 2) {
            return (b[n - 1] + 1 + move_heap_from_rod(n - 1, 0, pos)) % MOD;
        }
        assert(0);
    }
    if (rod == 2) {
        if (pos[n - 1] == 0) {
            return (2 * (a[n - 1] + 1) + move_heap_from_rod(n - 1, 2, pos)) % MOD;
        }
        if (pos[n - 1] == 1) {
            return (a[n - 1] + 1 + move_heap_from_rod(n - 1, 0, pos)) % MOD;
        }
        assert(0);
    }
    assert(0);
}

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> arr[i]; arr[i]--;
    }
    for (int i = 0; i < n; i++) {
        cin >> brr[i]; brr[i]--;
    }
    while (n > 0 && arr[n - 1] == brr[n - 1]) {
        n--;
    }
    if (n == 0) {
        cout << 0;
        return;
    }
    if (brr[n - 1] == 0) {
        if (arr[n - 1] == 1) {
            cout << (move_heap_from_rod(n - 1, 2, arr) + 1 + move_heap_from_rod(n - 1, 2, brr)) % MOD;
            return;
        }
        if (arr[n - 1] == 2) {
            cout << (move_heap_from_rod(n - 1, 0, arr) + 1 + a[n - 1] + 1 + move_heap_from_rod(n - 1, 2, brr)) % MOD;
            return;
        }
        assert(0);
    }
    if (brr[n - 1] == 1) {
        if (arr[n - 1] == 0) {
            cout << (move_heap_from_rod(n - 1, 2, arr) + 1 + move_heap_from_rod(n - 1, 2, brr)) % MOD;
            return;
        }
        if (arr[n - 1] == 2) {
            cout << (move_heap_from_rod(n - 1, 0, arr) + 1 + move_heap_from_rod(n - 1, 0, brr)) % MOD;
            return;
        }
        assert(0);
    }
    if (brr[n - 1] == 2) {
        if (arr[n - 1] == 0) {
            cout << (move_heap_from_rod(n - 1, 2, arr) + 1 + a[n - 1] + 1 + move_heap_from_rod(n - 1, 0, brr)) % MOD;
            return;
        }
        if (arr[n - 1] == 1) {
            cout << (move_heap_from_rod(n - 1, 0, arr) + 1 + move_heap_from_rod(n - 1, 0, brr)) % MOD;
            return;
        }
        assert(0);
    }
    assert(0);
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    pre();
    int t;
    cin >> t;
    while (t--) {
        solve();
        cout << endl;
    }
    return 0;
}
