#include <bits/stdc++.h>
using namespace ::std;

#define int long long
#define ll long long
#define YES "YES\n"
#define NO "NO\n"

int MOD = 998244353LL;

struct func {
    int p;
    int tower_k;

    func(int p0, int tower_k0) {
        p = p0;
        tower_k = tower_k0;
    }
};

int make_tower_it(int p, vector<int>& x, int tower_k, vector<int>& per1, vector<int>& per2) {
    int ans = 0;
    deque<pair<int, int>> st;
    st.push_back({p, tower_k});
    while(st.size() > 0) {
        int p_ = st.front().first;
        int tower_k_ = st.front().second;
        st.pop_front();
        while (p_ > 0) {
            if (x[p_] == tower_k_) {
                p_--;
            } else {
                break;
            }
        }
        if (p_ == 0) {
            continue;
        }
        int new_k = 6 - tower_k_ - x[p_];
        if (x[p_] == 2) {
            ans = (ans + 1 + per2[p_ - 1]) % MOD;
            st.push_front({p_ - 1, new_k});
            continue;
        }
        if (abs(tower_k - x[p_]) == 1) {
            ans = (ans + 1 + per1[p_ - 1]) % MOD;
            st.push_front({p_ - 1, new_k});
            continue;
        }
        else {
            ans = (ans + 1 + per2[p_ - 1] + 1) % MOD;
            st.push_front({p_ - 1, tower_k});
            continue;
        }
    }
    return ans;
}

int make_tower(int p, vector<int>& x, int tower_k, vector<int>& per1, vector<int>& per2) {
    while (p > 0) {
        if (x[p] == tower_k) {
            p--;
        } else {
            break;
        }
    }
    if (p == 0) {
        return 0;
    }
    int new_k = 6 - tower_k - x[p];
    if (x[p] == 2) {
        return (make_tower(p - 1, x, new_k, per1, per2) + 1 + per2[p - 1]) % MOD;
    }
    if (abs(tower_k - x[p]) == 1) return (make_tower(p - 1, x, new_k, per1, per2) + 1 + per1[p - 1]) % MOD;
    else return (make_tower(p - 1, x, tower_k, per1, per2) + 1 + per2[p - 1] + 1) % MOD;
}

void solve() {
    int n; cin >> n;
    vector<int> x(n + 1);
    vector<int> y(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> x[i];
    }
    for (int i = 1; i <= n; i++) {
        cin >> y[i];
    }

    vector<int> per1(n + 1);
    vector<int> per2(n + 1);
    per1[1] = 1;
    per2[1] = 2;
    for (int i = 2; i <= n; i++) {
        per1[i] = (per1[i - 1] + per2[i - 1] + 1) % MOD;
        per2[i] = (per2[i - 1] + 1 + per2[i - 1] + 1) % MOD;
    }

    int p = n;

    int ans = 0;

    while (p > 0 && x[p] == y[p]) {
        p--;
    }
    if (p == 0) {
        cout << 0 << '\n';
        return;
    }

    int tower_k = 6 - x[p] - y[p];

    if (x[p] == 2) {
        ans = (make_tower_it(p - 1, x, tower_k, per1, per2) + 1) % MOD;
    } else {
        if (abs(x[p] - y[p]) == 1) {
            ans = (make_tower_it(p - 1, x, tower_k, per1, per2) + 1) % MOD;
        } else {
            ans = (make_tower_it(p - 1, x, y[p], per1, per2) + 1 + per2[p - 1] + 1) % MOD;
            tower_k = x[p];
        }
    }
    p--;

    while (p > 0) {
        if (tower_k == y[p]) {
            p--;
            continue;
        }
        int new_k = 6 - tower_k - y[p];
        if (tower_k == 2) {
            ans = (ans + per1[p - 1] + 1) % MOD;
        } else {
            if (abs(tower_k - y[p]) == 1) {
                ans = (ans + per2[p - 1] + 1) % MOD;
            } else {
                ans = (ans + per2[p - 1] + 1 + per2[p - 1] + 1) % MOD;
            }
        }
        tower_k = new_k;
        p--;
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int tt = 1;
    cin >> tt;

    while (tt--) {
        solve();
    }
}
