#include <bits/stdc++.h>

#define int long long
#define pr pair < int, pair < int, char > >
#define mk make_pair

using namespace std;

void solve() {
  int n, x, m;
  char c;
  cin >> n;
  vector<pr > h(n);
  set<pr > reds, blues;
  int red = 0, blue = 0;
  for (int i = 0; i < n; i++) {
    cin >> x >> m >> c;
    if (c == 'R') {
      red += m;
    } else {
      blue += m;
    }
    h[i] = mk(x, mk(m, c));
  }
  sort(h.begin(), h.end());
  if (red == blue) {
    cout << "Draw 0 0\n";
    return;
  } else if (red > blue) {
    int winsteps = 0;
    for (int i = n - 1; i >= 0; i--) {
      if (h[i].second.second == 'B') {
        int need = 0;
        while (reds.size() > 0) {
          pr v = *(reds.begin());
          reds.erase(v);
          int kill = min(h[i].second.first, v.second.first);
          need += (v.first - h[i].first) * kill;
          h[i].second.first -= need;
          v.second.first -= need;
          if (v.second.first != 0) {
            reds.insert(v);
            break;
          }
        }
        winsteps += need;
        if (h[i].second.first != 0) {
          blues.insert(h[i]);
        }
      } else {
        int need = 0;
        while (blues.size() > 0) {
          pr v = *(blues.begin());
          blues.erase(v);
          int kill = min(h[i].second.first, v.second.first);
          need += (v.first - h[i].first) * kill;
          h[i].second.first -= kill;
          v.second.first -= kill;
          if (v.second.first != 0) {
            blues.insert(v);
            break;
          }
        }
        winsteps -= need;
        if (winsteps <= 0) {
          cout << "Draw ";
          for (int j = n - 1; j >= 0; j--) {
            if (h[j].second.second == 'R') {
              cout << h[j].first << + " +\n";
              return;
            }
          }
        }
        if (h[i].second.first != 0) {
          reds.insert(h[i]);
        }
      }
    }
    cout << "First ";
    for (int j = n - 1; j >= 0; j--) {
      if (h[j].second.second == 'R') {
        cout << h[j].first << + " +\n";
        return;
      }
    }
  } else {
    int winsteps = 0;
    for (int i = n - 1; i >= 0; i--) {
      if (h[i].second.second == 'B') {
        int need = 0;
        while (reds.size() > 0) {
          pr v = *(reds.begin());
          reds.erase(v);
          int kill = min(h[i].second.first, v.second.first);
          need += (v.first - h[i].first) * kill;
          h[i].second.first -= need;
          v.second.first -= need;
          if (v.second.first != 0) {
            reds.insert(v);
            break;
          }
        }
        winsteps -= need;
        if (winsteps < 0) {
          cout << "Draw ";
          for (int j = n - 1; j >= 0; j--) {
            if (h[j].second.second == 'R') {
              cout << h[j].first << + " +\n";
              return;
            }
          }
        }
        if (h[i].second.first != 0) {
          blues.insert(h[i]);
        }
      } else {
        int need = 0;
        while (blues.size() > 0) {
          pr v = *(blues.begin());
          blues.erase(v);
          int kill = min(h[i].second.first, v.second.first);
          need += (v.first - h[i].first) * kill;
          h[i].second.first -= kill;
          v.second.first -= kill;
          if (v.second.first != 0) {
            blues.insert(v);
            break;
          }
        }
        winsteps += need;
        if (h[i].second.first != 0) {
          reds.insert(h[i]);
        }
      }
    }
    cout << "Second\n";
  }
}

signed main() {
  int t;
  cin >> t;
  while (t--) {
    solve();
  }
}