
from math import sqrt

def main():
	n = int(input())
	res = 0

	# создаю список с данными об окружностях
	circls = []
	for _ in range(n):
		circls.append([int(i) for i in input().split()])

	# сравниваю каждый с каждым
	for i in range(n-1):
		for j in range(i+1, n):
			is_touch = touch(circls[i], circls[j])
			if is_touch:
				res += 1

	print(res)


def touch(circle_1: list, circle_2: list):
	x = abs(circle_1[0] - circle_2[0])
	y = abs(circle_1[1] - circle_2[1])
	r_1 = circle_1[2]
	r_2 = circle_2[2]

	if x == 0 and r_1 + r_2 == y:
		return True
	elif y == 0 and r_1 + r_2 == x:
		return True
	elif r_1 + r_2 == sqrt(x ** 2 + y ** 2):
		return True
	else:
		return False



if __name__ == "__main__":

	t = int(input())

	for _ in range(t):
		main()