#include <bits/stdc++.h>
using namespace std;

#define endl '\n'
#define ll long long
#define pb push_back
#define F first
#define S second

const int timeStart = 8 * 60;
const int threshold = 10;

pair<vector<set<int>>, int> input() {
    pair<vector<set<int>>, int> gr;
    int n, u, v;
    cin >> n >> gr.S;
    gr.F.resize(n);
    for (int i = 0; i < gr.S; ++i) {
        cin >> u >> v;
        --u, --v;
        gr.F[u].insert(v);
    }

    return gr;
}

void dfs(const vector<set<int>> &graph, int v, set<int> &met, vector<int> &ans) {
    met.insert(v);
    for (auto to : graph[v]) {
        if (!met.count(to)) {
            dfs(graph, to, met, ans);
        }
    }
    ans.pb(v);
}

vector<int> solve(const pair<vector<set<int>>, int> &input) {
    set<int> met;
    vector<int> ans;
    for (int i = 0; i < input.F.size(); ++i) {
        if (!met.count(i)) {
            dfs(input.F, i, met, ans);
        }
    }
    reverse(ans.begin(), ans.end());
    map<int, int> mp;
    for (int i = 0; i < ans.size(); ++i)
        mp[ans[i]] = i;
    int need = input.S / 2 + (input.S&1);
    for (int i = 0; i < input.F.size() && need; ++i) {
        for (auto to : input.F[i]) {
            need -= mp[i] < mp[to];
            if (!need) break;
        }
    }
    if (need) {
        reverse(ans.begin(), ans.end());
    }
    return ans;
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output1.txt", "w", stdout);
    #endif // LOCAL
    int t;
    cin >> t;
    while (t--) {
        auto ans = solve(input());
        if (ans.empty()) {
            cout << -1 << endl;
            continue;
        }
        for (auto to : ans)
            cout << to+1 << ' ';
        cout << endl;
    }
    return 0;
}
