#include <bits/stdc++.h>
using namespace std;

int main() {
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        vector <pair<int, int>> in_out;
        vector <int> in(n+1), out(n+1);
        vector <pair<int, int>> ed(m);
        for (int i = 0; i < m; ++i) {
            int u, v;
            cin >> u >> v;
            in[v]++;
            out[u]++;
            ed[i] = {u, v};
        }
        for (int i = 0; i < n; ++i) {
            in_out.emplace_back(out[i+1] - in[i+1], i+1);
        }
        sort(in_out.begin(), in_out.end(), [](pair <int, int> f, pair<int, int> s) {
            return f.first > s.first;
        });
        vector <int> order(n+1);
        for (int i = 0; i < n; ++i) {
            order[in_out[i].second] = i;
        }
        int c = 0;
        for (int i = 0; i < m; ++i) {
            int v = ed[i].first;
            int u = ed[i].second;
            if (order[v] > order[u]) {
                c++;
            }
        }
        if (c > m / 2) {
            cout << -1;
        } else {
            for (int i = 0; i < n; ++i) {
                cout << in_out[i].second << ' ';
            }
        }
        cout << '\n';
    }
}
