#include <bits/stdc++.h>
using namespace std;

int c = 0;
vector <int> top, used;
vector <vector <int>> g;

void topsort(int v) {
    used[v] = 1;
    for (int u : g[v]) {
        if (!used[u])
            topsort(u);
        else
            c++;
    }
    top.push_back(v);
}

int main() {
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        vector <pair<int, int>> in_out;
        vector <int> in(n+1), out(n+1);
        g.clear();
        used.clear();
        c = 0;
        top.clear();
        g.resize(n+1);
        used.resize(n+1);
        for (int i = 0; i < m; ++i) {
            int u, v;
            cin >> u >> v;
            in[v]++;
            out[u]++;
            g[u].push_back(v);
        }
        for (int i = 0; i < n; ++i) {
            in_out.emplace_back(out[i+1] - in[i+1], i+1);
        }
        sort(in_out.begin(), in_out.end(), [](pair <int, int> f, pair<int, int> s) {
            return f.first > s.first;
        });
        for (int i = 0; i < n; ++i) {
            int v = in_out[i].second;
            if (!used[v]) {
                topsort(v);
            }
        }
        reverse(top.begin(), top.end());
        if (c > m / 2) {
            cout << -1;
        } else {
            for (int i = 0; i < n; ++i) {
                cout << top[i] << ' ';
            }
        }
        cout << '\n';
    }
}
