from itertools import *
from string import ascii_lowercase


n, e = map(int, input().split())

class Keyboard:
    def __init__(self, alphabet, index=0):
        self.alphabet = alphabet
        self.index = index
    
    def __str__(self):
        return str((self.alphabet, self.index))
    
    def __repr__(self) -> str:
        return str((self.alphabet, self.index))
    
    def get(self):
        symbol = self.alphabet[self.index]
        self.index += 1
        self.index %= len(self.alphabet)
        return symbol
    
    def check(self):
        return self.alphabet[self.index]

alphabets = [input() for _ in range(n)]
strings = []
for i in range(1, e + 1):
    for comb in product(range(n), repeat=i):
        keyboards = [Keyboard(alphabets[j]) for j in range(n)]
        s = ""
        for index in comb:
            s += keyboards[index].get()
        strings.append(s)

attemps = []
for i in range(1, e + 1):
    for attemp in map(lambda x: "".join(x), product(ascii_lowercase[:e], repeat=i)):
        if attemp not in strings:
            print(attemp)
            exit()
print("NO")


