import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int n = scanner.nextInt();
        while (n > 0){
            int size = scanner.nextInt();
            long[] mountains1 = new long[size];
            long[] mountains2 = new long[size];
            readMountain(scanner, mountains1, mountains2);
            n--;
        }
    }

    private static void readMountain(Scanner scanner, long[] mountains1, long[] mountains2){
        for (int i = 0; i < mountains1.length; i++){
            mountains1[i] = scanner.nextInt();
        }
        for (int i = 0; i < mountains2.length; i++){
            mountains2[i] = scanner.nextInt();
        }
        long max = -1;
        for(int i = 0; i < mountains1.length; i++){
            long a = mountains2[i];
            long b = mountains1[i];
            if(a - b < 0){
                System.out.println(-1);
                return;
            }
            max = Math.max(max, a - b);
        }
        System.out.println(max);
    }
}