#include <bits/stdc++.h>

using namespace std;

int main()
{
        cin.tie(0);
    std::ios::sync_with_stdio(0);

    int t;
    cin >> t;

    while(t--)
    {
        int n, m;
        cin >> n >> m;

        vector<set<int>> adj(n);

        for (int i = 0; i < m; ++i)
        {
            int u,v;
            cin >> u >> v;
            u--; v--;
            adj[u].insert(v);
        }

        vector<int> res;
        for (int tt = 0; !res.size() && tt < 50; tt++)
        {
    using pii = pair<int,int>;
        vector<char> visited(n, 0);
        set<pii> erased;

        function<void(int, int)> dfs;
        int k = 0;
        dfs = [&](int v, int from)
        {
            if (visited[v] == 2)
                return;

            if (visited[v] == 1)
            {
                erased.insert({from, v});
                k++;
                return;
            }

            visited[v] = 1;
            for (int u : adj[v])
                if (!erased.count({v, u}))
                    dfs(u, v);
            visited[v] = 2;
        };

        vector<int> sh(n);
        for (int i = 0 ; i < n; i++)
            sh[i] = i;

        std::random_shuffle(sh.begin(), sh.end());
        for (int v = 0; v < n; v++)
            dfs(sh[v], -1);

        if (k > m/2)
        {
            cout << "-1\n";
            continue;
        }

        visited = vector<char>(n, 0);
        vector<int> topsort;
        function<void(int)> dfs1;
        dfs1 = [&](int v)
        {
            if (visited[v])
                return;
            
            for (int u : adj[v])
                if (!erased.count({v, u}))
                    dfs1(u);
            
            topsort.push_back(v);

            visited[v] = 1;
        };

        for (int v = 0; v < n; v++)
            dfs1(v);

        std::reverse(topsort.begin(), topsort.end());
        res = topsort;

        }

        if (res.size())
        {
        for (int v : res)
            cout << v+1 << ' ';
        cout << '\n';
        }
        else
            cout << "-1\n";
    }
}