#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define pll pair<ll, ll>

struct pnt {
    ll pos;
    ll am;
    char col;
};

void solve() {
    ll n; cin >> n;
    vector <pnt> s(n);
    ll bal = 0;
    for (ll i = 0; i < n; i++) {
        cin >> s[i].pos >> s[i].am >> s[i].col;
        if (s[i].col == 'R')
            bal += s[i].am;
        else
            bal -= s[i].am;
    }

    if (bal == 0) {
        cout << "Draw 0 0\n";
        return;
    }

    sort(s.begin(), s.end(), [](pnt a, pnt b){return a.pos < b.pos;});
    ll last_R = -1;

    bool we_can_win = bal > 0;
    ll ind = -1;

    bal = !we_can_win - 1;
    stack <pnt> st;

    int flag = 0;

    for (ll iii = n - 1; iii >= 0; iii--) {
        auto p = s[iii];

        if (p.col == 'R' && last_R == -1) {
            last_R = iii;
        }

        while (!st.empty()) {
            if (st.top().col == p.col) {
                break;
            }
            ll d = min(st.top().am, p.am);
            p.am -= d;
            st.top().am -= d;

            if ((we_can_win && p.col == 'B') || (!we_can_win && p.col == 'R')) {
                bal -= d * (st.top().pos - p.pos);
            } else {
                bal += d * (st.top().pos - p.pos);
            }

            if (st.top().am == 0)
                st.pop();
            
            if (p.am == 0)
                break;
        }
        if (p.am != 0) {
            st.push(p);
        }

        if (p.col == 'B') {
            flag = 1;
        }
        if (p.col == 'R' && flag == 1) {
            flag = 2;
            ind = iii;
        }

        if (we_can_win) {
            if (bal > 0) {
                cout << "Draw 0 0\n";
                return;
            }
        } else {
            if (bal > 0) {
                cout << "Draw " << s[last_R].pos << " +\n"; 
                return;
            }
        }
    }

    if (we_can_win) {
        cout << "First " << s[ind].pos << " +\n";
    } else {
        cout << "Second\n";
    }
}

main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    
    ll t; cin >> t;
    while (t--) {
        solve();
    }
}
