#include <bits/stdc++.h>

using namespace std;

#define int long long

void solve() {
    int n;
    cin >> n;

    vector<int> p(n);
    vector<int> h(n);

    for (int i = 0; i < n; i++) {
        cin >> h[i];
    }

    for (int i = 0; i < n; i++) {
        cin >> p[i];
    }

    vector<pair<int, int>> kek(n);

    for (int i = 0; i < n; i++) {
        kek[i] = {p[i], h[i]};

        if (p[i] < h[i]) {
            cout << -1 << '\n';
            return;
        }
    }

    sort(kek.begin(), kek.end());

    for (int i = 1; i < n; i++) {
        if (kek[i].second < kek[i - 1].second) {
            cout << -1 << '\n';
            return;
        }
    }

    sort(p.begin(), p.end());
    sort(h.begin(), h.end());

    vector<int> dp(n - 1);
    vector<int> dh(n - 1);

    for (int i = 0; i < n - 1; i++) {
        dp[i] = p[i + 1] - p[i];
    }

    for (int i = 0; i < n - 1; i++) {
        dh[i] = h[i + 1] - h[i];
    }

    int ans = 0;

    for (int i = 0; i < n - 1; i++) {
        ans += dp[i] - dh[i];
    }

    ans += p[0] - h[0];

    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    #endif

    int cntTests = 1;
    cin >> cntTests;
    for (int i = 1; i <= cntTests; i++) {
        solve();
    }
}
