#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define f first
#define s second
//#define x first
//#define y second
#define pb push_back
#define _ << ' ' <<
#define TEST ""
#define all(x) x.begin(), x.end()
#define mp make_pair
#define sz(x) (int)x.size()
//#define cerr if(0) cerr
//#define int long long
#define Time() (ld)clock() / CLOCKS_PER_SEC

//#pragma GCC optimize ("O3")
//#pragma GCC optimize ("Ofast")
//#pragma GCC target ("sse,sse2,sse3,sse4,avx,avx2")
//#pragma comment(linker, "/STACK:160777216")

//before loops:
//#pragma unroll(3)

using namespace std;
//using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<long long, long long> pll;

#ifdef LOCAL
    #define cerr cout
#else
    #define cerr if(0) cerr
#endif

//template<typename T>
//using orderd_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T1, typename T2>
__attribute__((always_inline)) common_type_t<T1, T2> min(const T1 &a, const T2 &b) {
    return a < b ? a : b;
}

template<typename T3, typename T4>
__attribute__((always_inline)) common_type_t<T3, T4> max(const T3 &a, const T4 &b) {
    return a > b ? a : b;
}

template<typename T>
using normal_queue = priority_queue<T, vector<T>, greater<T> >;


constexpr ll MOD = (ll)1e9 + 7;

constexpr ll pow(ll a, ll p, ll acc = 1) {
    return p == 0 ? acc : pow(a * a % MOD, p / 2, p % 2 == 0 ? acc : (acc * a) % MOD);
}

constexpr ll inv(ll a) {
    return pow(a, MOD - 2);
}

constexpr int TWO_INV = inv(2);

pll operator+(pll a, pll b) {
    return {a.first + b.first, a.second + b.second};
}

pll operator-(pll a, pll b) {
    return {a.first - b.first, a.second - b.second};
}

pll operator+(pll a, ll b) {
    return {a.first + b, a.second + b};
}

pll operator*(pll a, ll m) {
    return {a.first * m, a.second * m};
}

pll operator%(pll a, ll m) {
    return {a.first % m, a.second % m};
}

pll operator*(ll m, pll a) {
    return {a.first * m, a.second * m};
}

bool cond(const vector<int> &as, vector<pll> &repr, vector<ll> &xs, int ans) {
    repr[0] = {0, 1};
    for (int i = 1; i < as.size(); ++i) {
        repr[i] =  (make_pair((ll)as[i] - ans, 0) + (-2 * repr[i - 1] + 2LL * MOD) % MOD) % MOD;
    }
    repr[0] = (make_pair((ll)as[0] - ans, 0) + (-2 * repr[as.size() - 1] + 2LL * MOD) % MOD) % MOD;

    xs[0] = (repr[0].first * inv((1 - repr[0].second + MOD) % MOD)) % MOD;

    for (int i = 1; i < as.size(); ++i) {
        xs[i] = (repr[i].first + repr[i].second * xs[0]) % MOD;
    }
    for (int i = 1; i < as.size(); ++i) {
        if (2 * xs[i - 1] + xs[i] != as[i] - ans) {
            return false;
        }
    }
    return 2 * xs[as.size() - 1] + xs[0] == as[0] - ans;
}

void solve() {
    int n;
    cin >> n;
    vector<int> as(n);
    for (auto &a : as) cin >> a;

    vector<pll> repr(n);
    vector<ll> xs(n);
    int gr = *min_element(as.begin(), as.end());

    int ans = 0;
    for (int off = 0; off < 3; ++off) {
        int l = off, r = (gr - off) / 3 * 3 + off;
        if (r > gr) r -= 3;
        if (l > r) continue;

        while (l != r) {
            int m = (l + r - off * 2) / 6 * 3 + off + 3;
            if (cond(as, repr, xs, m)) {
                l = m;
            } else {
                r = m - 3;
            }
        }
        if (l > 0 && cond(as, repr, xs, l)) {
            ans = max(ans, l);
        }


    }
    cout << ans << "\n";
}

signed main() {
    cout << fixed << setprecision(10);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    //freopen(TEST".in", "r", stdin);
    //freopen(TEST".out", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int tests = 1;
    cin >> tests;
    while (tests--) {
        solve();
    }
    return 0;
}

