#include <algorithm>
#include <iostream>
#include <numeric>
#include <random>
#include <vector>

using namespace std;

#define ALL(c) c.begin(), c.end()

const int MOD = 998244353;

int sum(int x, int y) {
  return x + y < MOD ? x + y : x + y - MOD;
}

int mul(int x, int y) {
  return x * 1LL * y % MOD;
}

const int N = 1e5 + 7;

int n;
int h[N], p[N];

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  int t;
  cin >> t;
  while (t--) {
    cin >> n;
    for (int i = 0; i < n; ++i) {
      cin >> h[i];
    }
    for (int i = 0; i < n; ++i) {
      cin >> p[i];
    }
    vector<pair<int, int>> arr;
    bool flag = false;
    int ans = 0;
    for (int i = 0; i < n; ++i) {
      arr.push_back({p[i], p[i] - h[i]});
      ans = max(ans, p[i] - h[i]);
      if (p[i] - h[i] < 0) {
        flag = true;
      }
    }
    sort(ALL(arr));
    for (int i = 0; i < n - 1; ++i) {
      if (arr[i].second > arr[i + 1].second) {
        flag = true;
      }
    }
    if (flag) {
      cout << "-1\n";
    } else {
      cout << ans << '\n';
    }
  }
  return 0;
}