#include <bits/stdc++.h>
 
using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;
 
const ll maxn = ll(1e5)+2;
const ll mod = 988244353;
 
ll binpow(ll n, ll a) {
    if (a == 0) return 1;
    if (a%2) return n*binpow(n, a-1)%mod;
    ll t = binpow(n, a/2);
    return t*t%mod;
}

ll dp[maxn][3][3];

ll mem[maxn][3][3];

ll f(vector<ll> &p1,ll n, int fin){
    if(n==0){
        return dp[n][p1[n]][fin];
    }
    while(n && fin == p1[n]) n--;
    if(n==-1) return 0;
    ll v = p1[n];
    ll u;
    if(v == 0){
        u = 2;
    }else if(v == 1){
        if(fin==0) u = 2;
        else u = 0;
    }else{
        u = 0;
    }
    ll ans = f(p1, n-1, u);
    ans%=mod;
    if(v == 0){
        if(fin == 2){
            ans++;
            ans+=dp[n][2][0];
            ans++;
            ans+=dp[n][0][2];
        }else if(fin == 1){
            ans++;
            ans+=dp[n][0][1];
        }
    }else if(v == 1){
        ans++;
        ans+=dp[n][2][0];
    }else{
        if(fin == 0){
            ans++;
            ans+=dp[n][2][0];
            ans++;
            ans+=dp[n][0][2];
        }else if(fin == 1){
            ans++;
            ans+=dp[n][0][1];
        }
    }
    ans%=mod;
    return ans;
}

ll go(vector<ll> &p1, vector<ll> &p2, ll n, bool flag = 1){
    if(n<0){
        return 0;
    }
    if(p1[n]==p2[n]) return 0;
    if(flag){
        int v = p1[n];
        int fin = p2[n];
        int u;
        if(v == 0){
            u = 2;
        }else if(v == 1){
            if(fin==0) u = 2;
            else u = 0;
        }else{
            u = 0;
        }
        ll ans = f(p1, n-1, u);
        if(v == 0){
            if(fin == 2){
                ans++;
                ans+=dp[n][2][0];
                ans++;
                ans+=dp[n][0][2];
            }else if(fin == 1){
                ans++;
                ans+=dp[n][0][1];
            }
        }else if(v == 1){
            ans++;
            ans+=dp[n][2][0];
        }else{
            if(fin == 0){
                ans++;
                ans+=dp[n][2][0];
                ans++;
                ans+=dp[n][0][2];
            }else if(fin == 1){
                ans++;
                ans+=dp[n][0][1];
            }
        }
        ans%=mod;
        return ans;

    }else{
        return dp[n][p1[n]][p2[n]];
    }
}

void solve() {
    ll n;
    cin >> n;
    vector<ll> p1(n), p2(n);
    for (int i=0;i<=n;++i){
        for (int j=0;j<9;++j) mem[i][j/3][j%3]=-1;
    }
    for (int i=0;i<n;++i) {
        cin >> p1[i];
        p1[i]--;
    }
    for (int i=0;i<n;++i) {
        cin >> p2[i];
        p2[i]--;
    }
    while (n && p1[n-1] == p2[n-1])n--;
    if (n == 0) {
        cout << 0 << '\n';
        return;
    }
    ll ans = go(p1, p2, n, 0);
    for(int x = n-2; n>=0;n--){
        ans+= go(p1,p2,x);
        ans%=mod;
    }
    cout << ans << '\n';
}
 
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    dp[1][0][1] = 1;
    dp[1][0][2] = 2;
    dp[1][1][2] = 1;
    dp[1][1][0] = 1;
    dp[1][2][1] = 1;
    dp[1][2][0] = 2;
    for (int i=2;i<maxn;++i) {
        for (int j=0;j<9;++j) {
            ll a = j/3;
            ll b = j%3;
            if (a == b) {
                dp[i][a][b] = 0;
                continue;
            }
            ll c = 1^2^b^a;
            if (c == 0 || c == 2) {
                dp[i][a][b] = 1 + dp[i-1][a][c] + dp[i-1][c][b];
            }
            else {
                dp[i][a][b] = dp[i-1][a][b] + 1 + dp[i-1][b][a] + 1 + dp[i-1][a][b];
            }
            dp[i][a][b] %= mod;
        }
    }
    ll t=1;
    cin >> t;
    while(t--)solve();
    return 0;
}