#include <iostream>
#include <vector>
#include <string>
#include <set>

using namespace std;
using ll = long long;
using pll = pair<ll, ll>;

#define vll vector<ll>

void solve() {
    ll n; cin >> n;
    vll a(n);

    for(auto &i : a)
        cin >> i;

    if (n == 2) {
        cout << max((ll) 0, min(a[0], a[1]) - abs(a[0] - a[1])) << '\n';
        return;
    }

    set<pair<pll, ll>> s;

    for(int i = 0; i < n; ++i) {
        int prev_ind = i - 1;
        if (prev_ind < 0) prev_ind = n - 1;
        s.insert(make_pair(make_pair(a[i], a[prev_ind]), i));
    }

    /*for(auto &i : s) {
        cout << i.first.first << ' ' << i.first.second << ' ' << i.second << '\n';
    }
    cout << "----------------\n";*/

    while(s.begin() -> first.first != s.rbegin() -> first.first) {
        auto it = s.end();
        --it;

        //cout << it->first.first << ' ' << it->first.second << ' ' << it->second << '\n';

        ll f = it->first.first, sec = it->first.second;
        ll ind = it->second;


        /*cout << "show me:\n";

        for(auto &i : s) {
            cout << i.first.first << ' ' << i.first.second << ' ' << i.second << '\n';
        }

        cout << "--***********_______\n";
        for(auto &i : a) {
            cout << i << ' ';
        }
        cout << "\n\n";*/

        s.erase(it);

        ll ppi = ind - 2;
        if (ppi < 0)
            ppi = n + ppi;

        ll ni = (ind + 1) % n;
        auto next = s.find(make_pair(make_pair(a[ni], f), ni));
        s.erase(next);

        //cout << sec << ' ' << a[ppi] << ' ' << ppi << ' ' << (ppi + 1) % n << '\n';
        auto c = s.find(make_pair(make_pair(sec, a[ppi]), (ppi + 1) % n));

        //if (c == s.end()) {
        //    cout << "end";
        //}
        s.erase(c);

        f -= 2;
        sec--;

        a[ind] -= 2;
        a[ind] = max(a[ind], (ll)0);

        a[(ppi + 1) % n]--;
        a[(ppi + 1) % n] = max((ll) 0, a[(ppi + 1) % n]);

        f = max(f, (ll)0);
        sec = max(sec, (ll)0);

        //cout << "***" << f << ' ' << sec << ' ' << ind << ' ' << ppi << '\n';

        s.insert(make_pair(make_pair(a[ni], f), ni));
        //cout << "888 " << f << ' ' << sec << ' ' << ind << '\n';
        s.insert(make_pair(make_pair(f, sec), ind));
        //cout << "777 " << sec << ' ' << a[ppi] << ' ' << (ppi + 1) % n << '\n';
        s.insert(make_pair(make_pair(sec, a[ppi]), (ppi + 1) % n));
    }

    cout << s.begin()->first.first << '\n';
}
int main() {
    cout.tie();
    cin.tie();
    ios_base::sync_with_stdio(false);

    ll t;
    cin >> t;
    while(t--) solve();
}
