#include <algorithm>
#include <cassert>
#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <map>
#include <deque>
using namespace std;
using ll = long long;


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<int> a(n), p(n);
        for (int i = 0; i< n;i++) cin >> a[i];
        for (int i = 0; i< n;i++) cin >> p[i];

        vector<pair<int, int>> pi;
        for (int i = 0; i < n;i++)  {
            pi.push_back({p[i], i});
        }
        sort(pi.begin(), pi.end());
        reverse(pi.begin(), pi.end());

        int last = 1e9;
        bool fl = 0;
        int ans = 0;
        for (int i = 0; i < n;i++) {
            int ind = pi[i].second;
            if (i + 1 < n) {
                int ind2 = pi[i + 1].second;
                if (p[ind] == p[ind2] && a[ind] != a[ind2])
                    fl = 1;
                if (a[ind] < a[ind2])
                    fl = 1;
            }
            if (p[ind] < a[ind])
                fl = 1;
        }
        for (auto v : pi) {
            int ind = v.second;

            int cur = p[ind] - a[ind];
            if (cur > last)
                fl = 1;
            last =cur;
            ans = max(ans, cur);
        }
        if (fl) cout << -1;
        else cout << ans;
        cout << "\n";
    }
}